C------------------------------------------------------------------------
      Subroutine SMinit
C--Sets input parameters
      Include 'SMallx.inc'
      Integer nobran,ikincut
      common/myvar/nobran,ikincut
      Double Precision pbeam1,pbeam2
	Integer Iseed,minuts
	External minuts
	Double Precision Rdq,SMrgen
	Double Precision Ca
	Integer nf
      Double Precision Lambda,QQg	
	Common/hardme/Lambda,QQg,nf
	logical my_glu	
	common/glumy/my_glu
C for Sudakov (smqtem.f) B is fixed: B=0.5	
C choose BB: 0, 0.5 , 1.	
	Double Precision BB
	Common /splitting/ BB
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision Xnorm
      common/smnorm/ Xnorm
      Logical pdflib,quark,gluon,photon,kernel
      Common /SMbran2/pdflib,quark,gluon,photon,kernel
	Double Precision mz
	Data mz/91.188d0/
	Logical First
	Common /SMstart/ First
      CHARACTER   FILENAME*132
      Common/gludatf/filename
      
c      double precision dummy, smrset
      
	First = .true.

c	photon = .false.
c	gluon =.true.
c	gluon =.false.
c	pdflib=.true.
	pdflib=.false.
      if(photon) then
           gluon=.true.
        endif
        if(gluon) then
           quark=.false.
           else
           quark=.true.
        endif
C---One loop or all loops evolution?
c      onel=.false.
c      onel=.true.
C---Power or one-loop form for input?
c      powin=.false.
      powin=.true.
c     Ipgg = 0 ! Pgg=(as(k)*1/z +as(q)*1/(1-z))   
c     Ipgg = 1 ! Pgg=(as(k)*B(1-z)/z +as(q)*B*z/(1-z)), Gavins full splitting
c     Ipgg = 2 ! Pgg=(as(q)*1/z +as(q)*1/(1-z)), as(q) eveywhere
c     Ipgg = 3 ! Pgg=(as(q)*B(1-z)/z +as(q)*B*z/(1-z)), as(q) eveywhere + full split
      BB=0.5
c      BB = 0.3
      scal = 1.	

c set my values
c glugrid =false no gluon file output (glu.dat)
c glugrid = true gluon file output (glu.dat)
      my_glu = .true.
	
c nobran = 0 --> standard initial state branching
c nobran = 1 --> no initial state branching
c nobran = 2 --> read ccfm.dat file
      nobran = 0
c      nobran = 1
c ikincut = 0 no kin cut
c         = 1 LDC kin cut	
c         = 2 MK kin cut
c         = 3 BFKL kin cut
cc	ikincut = 0 ! now in steering
c		

      write(6,*) ' smini: ikincut = ',ikincut,' QCDlam = ',QCDlam
      write(6,*) ' smini: Qg = ',Qg, ' Qs = ',Qs

c--power input form is (1/x)**pow0*(1-x)**pow1
c parameters from DIS2012
      pow0=0.189   
      pow1=1.926   !  
c

      a0=1.0

c here include a factor of pi coming from d^2 k --> dkt^2	
        if(onel) then
           Xnor = Xnorm * 3.1415927
           else
           Xnor = Xnorm * 3.1415927
        Endif

      Qx=Qs/Sqrt(2.)
      Is=50708061
c	IS = MINUTS()
	write(6,*) ' before smrset ',Is
	Iseed = Is
	Iseed = IABS(Is)
      Call SMrset(Iseed)
	write(6,*) ' after smrset ',Is

      Maxpr=5
      Nmongo=27
C---Number of events
      Nev=10000000 
cc      Nev=5000000 ! old 

      Print *
      Print *,' Number of events requested:',Nev
C---Timelike evolution of emitted gluons?
      tevol=.false.
c      tevol=.true.

C  LHC
C
      pbeam1=7000.
      pbeam2=7000.
C--Light quarks+ charm
      Qmas=0.25
	Ichg=4
      Idq=2
C--Magic conversion factor for gluons->charged hadrons
C      Gluch=2.5
      Gluch=1.0
C--Hot spot study?
C      hspot=.true.
      hspot=.false.
C--Set up beams: 1=electron, 2=proton
      p1(1)=0.
      p1(2)=0.
      p1(3)=-pbeam1
c      p1(5)=0.00051
      p1(5)=0.
      p1(4)=Sqrt(p1(3)**2+p1(5)**2)
      p2(1)=0.
      p2(2)=0.
      p2(3)=pbeam2
c      p2(5)=0.93827
      p2(5)=0.
      p2(4)=Sqrt(p2(3)**2+p2(5)**2)
      espec(5)=p1(5)
      pspec(5)=p2(5)
c      write(6,*) Sbig,p1(5)**2+p2(5)**2+2.*(p1(4)*p2(4)-p1(3)*p2(3))
      Sbig=p1(5)**2+p2(5)**2+2.*(p1(4)*p2(4)-p1(3)*p2(3))
c      write(6,*) Sbig,p1,p2
c      pause
C--Limit for branching
      Imax=1000
C--xmin.le.kinematic limit
      xymin=4.*Qmas**2/Sbig
ccc	fixed xmin
	xymin = 1e-7
      xmin=xymin
      xmax=.9999999
C--y range (y=momentum fraction of virtual photon)
      ymin=xymin
      ymax=.9999999
C--Q range
      me=0.511E-3
      Qmin=ymin*me
      Qmax=sqrt(ymax*Sbig)
c	Qmax=5.
c      Qmin=1.4
C  Min Q value
      Qmin=sqrt(1.)
      If (hspot) then
C  Min Q value
        Qmin=sqrt(20.)
C  Min x of trigger jet
        Xmjtrg=0.01
        Ppjtrg=Xmjtrg*2.*pbeam2
C  Min pt of trigger jet
        Ptjtrg=Qmin
C  Min tan-theta of trigger jet
        Thjtrg=Tan(10.*3.14159/180.)
        Print *,' Hot spot study with parameters:'
        Print *,' Min Q,xj,ptj,tanj =',Qmin,Xmjtrg,Ptjtrg,Thjtrg
      Endif

C--Nf=0: Capb=C_A/pi/b
      Capb=12./11.
C - now include also nf=4
      nf = 4
	QQg=Qg
	Lambda=QCDlam
	Ca = 3.
	Capb = 12.*Ca/(11*Ca - 2.*nf)
      Tg=Log(Qg/QCDLam)
      Tgg=Tg+Log(2.)
      Ts=Log(Qs/QCDLam)

      Print *
      If (onel) then
        Print *,' Running alpha, Q-ordering => 1-loop'
      Else
        Print *,' Running alpha, Angle-ordering => all loops'
      Endif
      Print *
      Print *,' Qmax,Qg,Qs,QCDLam =',Qmax,Qg,Qs,QCDLam
	write(6,*) ' alpha_s(m_z) = ',3.1415/3*Capb/Log(mz**2/QCDLam**2)
      Print *
      Print *,' Qmas,xmin =',Qmas,xmin
      Print *
      If (powin) then
c--power input form
        Print *,' Input xF(x) is (1/x)**p0*(1-x)**p1'
c--Lipatov exponent
c        p0=2.*Log(2.)*Capb/Ts
        Print *,' p0,p1 =',pow0,pow1
        If (pow0.ne.0.) then
          xmp0=1.-xmin**pow0
          q0=-1./pow0
        Endif
      Else
c--1 loop input form
        Print *,' Input xF(x) is Exp(a0*SqrtLn1/x)*(1-x)**p1'
        Print *,' a0,p1 =',a0,pow1
c  u=sqrt(ln1/x)
        umax=Sqrt(-Log(xmin))
        emax=Exp(a0*umax)-1.
      Endif
      Jev=0
	Return
      End
