      Subroutine SMqtem(Tlike)
C--Finds Qtem
      Include 'SMallx.inc'
      Double Precision U0,Ul,R,D,C
      Integer n
	
	
	 Real sudint,suda,fl,fu,eps
	 Double Precision q2hi,q2lo,qs0,Ca,nf,Lambda
	 Common/sudvar/q2hi,q2lo,qs0,Ca,nf,Lambda
	 External suda,fl,fu
C Parameters for Sudakov form factors
C (NMXSUD= max no of entries in lookup table)
	Real ACCUR,QEV,SUD
	Integer INTER,NQEV,NSUD
	Integer NMXSUD
      PARAMETER (NMXSUD=1024)
      COMMON/SMUSUD/ACCUR,QEV(NMXSUD,6),SUD(NMXSUD,6),INTER,NQEV,NSUD
	Real Fdiv(NMXSUD),Adiv(NMXSUD)
      Integer Isud
	Common/SMSUD1/Isud
	Double Precision Qtemgg,Ttemgg,Qtemqq,Ttemqq,Qtemqg,Ttemqg
	Common/SMSUD2/ Qtemgg,Ttemgg,Qtemqq,Ttemqq,Qtemqg,Ttemqg
      Logical pdflib,quark,gluon,photon
      Common /SMbran2/pdflib,quark,gluon,photon
	Real sudlo,sudup
	Double Precision power,qfac,qnow
	Real Qtest,Stest
	Real Qlim,Sudmin(3),Sudmax(3)
	 
	Real DIVDIF
	External DIVDIF
	 
	Integer IQ,ISS,I,L,L1,L2,LL
	Logical First
      Common /SMstart/ First
	Integer Iseed,minuts
	Double Precision SMrgen
	External minuts
	Common/random/Iseed
	Double Precision ana,t0,t,tmin
	Integer Ismax
	 
CCC	 
      Logical Tlike
      Data Eps/1.E-5/
      If (Tlike) then
	
	  write(6,*) ' this version of smqtem is not valid for tlike '
	  
	  stop
	  
	  endif
c HERWIG like parameter setting	 
	 NQEV=1024
	 NSUD = 0
	 INTER=3
c	 INTER=1
	 ACCUR=1.D-6
	 qlim = sqrt(Sbig)
c 	 
	 nf=4.
	 Lambda=0.2
	 Ca=3.
	 eps = ACCUR
	 
	 Qs0 = Qg
	 Ismax = 3
	 If(gluon) Ismax = 1
	 
	 IF(first) Then
c	  write(6,*) ' integrate Sudakov and produce lookup table'
        POWER=1./Real(NQEV-1)
        q2lo=Qs0**2
        QFAC=(1.1*qlim/sqrt(q2lo))**POWER
C--IS=1 FOR GLUON->GLUON+GLUON FORM FACTOR
C--IS=2 FOR quark->gluon+quark FORM FACTOR
C--IS=3 FOR quark->quark+GLUON FORM FACTOR
        DO 11 Is = 1,Ismax
cccc        IS = 1 ! inserted
	  Isud = Is
	  ISS=IS
        SUD(1,IS)=0.
        QEV(1,IS)=q2lo
	  Sudmin(is)=99999999.
	  Sudmax(is)=-9999999.
	  Isud = Is
        DO 10 IQ=2,NQEV
        QNOW=QFAC*sqrt(QEV(IQ-1,IS))
	  q2hi = Qnow**2
     	  call gadap2(0.,1.,fl,fu,suda,eps,sudint)
c        write(6,*) ' sud int: Sud = ',sudint,qnow
        SUD(IQ,IS)=sudint
	  if(sudint.lt.sudmin(is)) sudmin(is)=sudint
	  if(sudint.gt.sudmax(is)) sudmax(is)=sudint
   10   QEV(IQ,IS)=q2hi
c        write(6,*) ' new Sudakov ala Gavin '
c        WRITE(6,201) ISS,NQEV
c  201   FORMAT(1H1//10X,'EXTRACT FROM TABLE OF SUDAKOV FORM FACTOR NO.',
c     &  I2,' (',I5,' ACTUAL ENTRIES)'//10X,'SUD IS PROBABILITY THAT',
c     &  ' PARTON WITH GIVEN UPPER LIMIT ON Q WILL REACH THRESHOLD',
c     &  ' WITHOUT BRANCHING'///2X,8('      Q     SUD ')/)
        L2=NQEV/8
        L1=L2/32
        IF (L1.LT.1) L1=1
        DO 40 L=L1,L2,L1
        LL=L+7*L2
c        WRITE(6,30) (sqrt(QEV(I,IS)),exp(-SUD(I,IS)),I=L,LL,L2)
   30   FORMAT(2X,8(F9.2,F7.4))
   40   CONTINUE
c        WRITE(6,50)
   50   FORMAT(1H1)
	 
   11   Continue	 
	 first=.false.
c       Call SMrset(Iseed)
c  	 write(6,*) ' in smqtem after smrset ',Iseed
	 endif
 
	
	q2lo = QCDlam*exp(Told)
	q2lo = q2lo**2
	Qtest=q2lo
	Do Is=1,Ismax
cc	Do I=1,nqev
cc	Fdiv(i)=SUD(i,IS)
cc	Adiv(i)=QEV(i,IS)
cc	Enddo
cc      sudlo=DIVDIF(Fdiv,Adiv,NQEV,Qtest,INTER)	 
      sudlo=DIVDIF(SUD(1,IS),QEV(1,IS),NQEV,Qtest,INTER)	 
	
      R=SMrgen(1)
      If (R.eq.0.) R=Eps
      D=-Log(R)	 
	stest = D + sudlo
      if(stest.gt.Sudmax(is)) then
c	  write(6,*) ' smqtem : stest,sudmin',stest,sudmin(is),sudmax(is)
	  stest=min(stest,sudmax(is))
	  endif 
      if(stest.lt.Sudmin(is)) then
c	  write(6,*) ' smqtem : stest,sudmin',stest,sudmin(is),sudmax(is)
	  stest=max(stest,sudmin(is))
	  endif 

	if(sudlo.gt.stest) then
	   write(6,*) ' sudlo ',sudlo,stest,sudmin(is),sudmax(is)
	endif
	
cc	Do I=1,nqev
cc	Adiv(i)=SUD(i,IS)
cc	Fdiv(i)=QEV(i,IS)
cc	Enddo
	  
cc      Qtest = DIVDIF(Fdiv,Adiv,NQEV,stest,INTER)
      Qtest = DIVDIF(QEV(1,IS),SUD(1,IS),NQEV,stest,INTER)
	
      Qtem=sqrt(Max(0.,Qtest))
	Qtem=Max(Qg,Qtem)
      Ttem = log(Qtem/QCDLam)

	if(Ttem.lt.Told) then
	  write(6,*) ' smqtem_new problem: Ttem < Told ',Ttem,Told,Is
	  write(6,*) ' smqtem_new problem: Qtem < Qold ',Qtem,q2lo,Is
	Endif
      If(IS.eq.1) then
         Qtem=sqrt(Max(0.,Qtest))
	   Qtem=Max(Qg,Qtem)
         Ttem = log(Qtem/QCDLam)
	
	   if(qtem.eq.0.) then
	      write(6,*) ' smqtem problem Qtem:',Qtem,Qtest,stest,D,
     &	    sudlo,q2lo,R,sudmin(is),sudmax(is)
            Qtem=Qg+Eps
            Ttem=Tg
            Ttem = log(Qtem/QCDLam)
	   endif
	   if(qtem.le.Qg) then
	      write(6,*) ' smqtem problem Qtem:',Qtem,Qg
            Qtem=Qg+Eps
            Ttem = log(Qtem/QCDLam)
	   endif
 
	   if(Qtem.ne.Qtem) then 
	      write(6,*) ' smqtem problem Qtem:',Qtem,Qtest,stest,
     &		D,sudlo,q2lo
	   endif
	   Qtemgg = Qtem
         Ttemgg = Ttem
      Elseif(IS.eq.2) then
         Qtemqg=sqrt(Max(0.,Qtest))
	   Qtemqg=Max(Qg,Qtemqg)
         Ttemqg = log(Qtemqg/QCDLam)
	
	   if(qtemqg.eq.0.) then
	      write(6,*) ' smqtem problem Qtem:',Qtemqg,Qtest,stest,D,
     &	    sudlo,q2lo,R,sudmin(is),sudmax(is)
            Qtemqg=Qg+Eps
            Ttemqg=Tg
            Ttemqg = log(Qtemqg/QCDLam)
	   endif
	   if(qtemqg.le.Qg) then
	      write(6,*) ' smqtem problem Qtem:',Qtem,Qg
            Qtemqg=Qg+Eps
            Ttemqg = log(Qtemqg/QCDLam)
	   endif
      Elseif(IS.eq.3) then
         Qtemqq=sqrt(Max(0.,Qtest))
	   Qtemqq=Max(Qg,Qtemqq)
         Ttemqq = log(Qtemqq/QCDLam)
	
	   if(qtemqq.eq.0.) then
	      write(6,*) ' smqtem problem Qtem:',Qtemqq,Qtest,stest,D,
     &	    sudlo,q2lo,R,sudmin(is),sudmax(is)
            Qtemqq=Qg+Eps
            Ttemqq=Tg
            Ttemqq = log(Qtemqq/QCDLam)
	   endif
	   if(qtemqq.le.Qg) then
	      write(6,*) ' smqtem problem Qtem:',Qtem,Qg
            Qtemqq=Qg+Eps
            Ttemqq = log(Qtemqq/QCDLam)
	   endif
	endif
	Enddo
      End
	
	 Function suda(x,y)
	 Implicit None
	 Real x,y
	 Double Precision q2hi,q2lo,q0,Ca,nf,Lambda
	 Common/sudvar/q2hi,q2lo,q0,Ca,nf,Lambda
	 Real Suda
	 Double Precision q,q2,z1,z1min,z1max
	 Double Precision Capb,asb,Lambda2,Sudakov
	 Double Precision Splitt,Splittqg,Splittqq,asbmy
	 External Splitt,Splittqg,Splittqq,asbmy
	 Double Precision BB
	 Common /splitting/ BB
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal
      Integer Isud
	Common/SMSUD1/Isud	
	Double Precision Psplit
	Double Precision Cf
	
	Cf = 4d0/3d0
 
C for the sudakov, set B always to 0.5
       BB = 0.5	 
C	 
	 q2=q2lo*(q2hi/q2lo)**x
	 q=sqrt(q2)
c z1= 1-z	
c z1min= = Q0/q, z1max=1
       z1min=q0/q
	 z1max=1.
	 z1= z1min*(z1max/z1min)**y
	 sudakov=1.
	 Capb=12.*Ca/(11.*Ca-2.*nf)
c	 asb= 0.5*Capb/log(q*z1/Lambda)
C--Isud=1 FOR GLUON->GLUON+GLUON FORM FACTOR
	 if(Isud.eq.1) then 
	   Psplit=Splitt(z1)
	 elseif(Isud.eq.2) then 
	   Psplit=Splittqg(z1)*Cf/Ca
	 elseif(Isud.eq.3) then 
	   Psplit=Splittqq(z1)*Cf/Ca
	 else
	   write(6,*)' Isud = ',Isud,' not implemented '
	 endif
c asbmy = C_A/pi * alpha_s
       sudakov = asbmy(scal*q*z1) *Psplit/q2	 
ccc       sudakov = asb/q2/z1	 ! for tesing only
	 
c	 write(6,*) q2,q2lo,q2hi,x,z1,z1min,z1max,y
c       write(6,*) ' alphas ',asb
c	 
	 sudakov=sudakov*q2*log(q2hi/q2lo)*z1*log(z1max/z1min)
	 suda=sudakov
	 return
	 end
	Function Splittqg(z1)
C--IS=2 FOR quark->gluon+quark FORM FACTOR
	Implicit None

	Double Precision Splittqg,z1
      Splittqg = 1./z1 
	Return
	End 
	
	Function Splittqq(z1)
C--IS=3 FOR quark->quark+GLUON FORM FACTOR
	Implicit None

	Double Precision Splittqq,z1
      Splittqq = 1./z1
	Return
	End 
	 
	 
	 Function fl(x)
	 real fl,x
	 fl=0.
	 return
	 end
	 function fu(x)
	 real fu,x
	 fu=1.
	 return
	 end
	 
	 
C#######################################################################
C
C   One- and two-dimensional adaptive Gaussian integration routines.
C
C **********************************************************************

      SUBROUTINE GADAP(A0,B0,F,EPS,SUM)
	IMPLICIT NONE
C
C   PURPOSE           - INTEGRATE A FUNCTION F(X)
C   METHOD            - ADAPTIVE GAUSSIAN
C   USAGE             - CALL GADAP(A0,B0,F,EPS,SUM)
C   PARAMETERS  A0    - LOWER LIMIT (INPUT,REAL)
C               B0    - UPPER LIMIT (INPUT,REAL)
C               F     - FUNCTION F(X) TO BE INTEGRATED. MUST BE
C                       SUPPLIED BY THE USER. (INPUT,REAL FUNCTION)
C               EPS   - DESIRED RELATIVE ACCURACY. IF SUM IS SMALL EPS
C                       WILL BE ABSOLUTE ACCURACY INSTEAD. (INPUT,REAL)
C               SUM   - CALCULATED VALUE FOR THE INTEGRAL (OUTPUT,REAL)
C   PRECISION         - SINGLE
C   REQ'D PROG'S      - F
C   AUTHOR            - T. JOHANSSON, LUND UNIV. COMPUTER CENTER, 1973
C   REFERENCE(S)      - THE AUSTRALIAN COMPUTER JOURNAL,3 P.126 AUG. -71
C
	Integer Num,Ifu,N,L,I
	Real F,A,B,F1,F2,F3,S,F1F,F2F,F3F,AA,BB,EPS,RED,SUM,C
	Real A0,B0,DSUM,W1,U2,SOLD,SS
      COMMON/GADAP1/ NUM,IFU
      EXTERNAL F
      DIMENSION A(300),B(300),F1(300),F2(300),F3(300),S(300),N(300)

      DSUM(F1F,F2F,F3F,AA,BB)=5./18.*(BB-AA)*(F1F+1.6*F2F+F3F)
      IF(EPS.LT.1.0E-8) EPS=1.0E-8
      RED=1.3
      L=1
      I=1
      SUM=0.
      C=SQRT(15.)/5.
      A(1)=A0
      B(1)=B0
      F1(1)=F(0.5*(1+C)*A0+0.5*(1-C)*B0)
      F2(1)=F(0.5*(A0+B0))
      F3(1)=F(0.5*(1-C)*A0+0.5*(1+C)*B0)
      IFU=3
      S(1)=  DSUM(F1(1),F2(1),F3(1),A0,B0)
   10 CONTINUE
      L=L+1
      N(L)=3
      EPS=EPS*RED
      A(I+1)=A(I)+C*(B(I)-A(I))
      B(I+1)=B(I)
      A(I+2)=A(I)+B(I)-A(I+1)
      B(I+2)=A(I+1)
      A(I+3)=A(I)
      B(I+3)=A(I+2)
      W1=A(I)+(B(I)-A(I))/5.
      U2=2.*W1-(A(I)+A(I+2))/2.
      F1(I+1)=F(A(I)+B(I)-W1)
      F2(I+1)=F3(I)
      F3(I+1)=F(B(I)-A(I+2)+W1)
      F1(I+2)=F(U2)
      F2(I+2)=F2(I)
      F3(I+2)=F(B(I+2)+A(I+2)-U2)
      F1(I+3)=F(A(I)+A(I+2)-W1)
      F2(I+3)=F1(I)
      F3(I+3)=F(W1)
      IFU=IFU+6
      IF(IFU.GT.5000) GOTO 40
      S(I+1)=  DSUM(F1(I+1),F2(I+1),F3(I+1),A(I+1),B(I+1))
      S(I+2)=  DSUM(F1(I+2),F2(I+2),F3(I+2),A(I+2),B(I+2))
      S(I+3)=  DSUM(F1(I+3),F2(I+3),F3(I+3),A(I+3),B(I+3))
      SS=S(I+1)+S(I+2)+S(I+3)
      I=I+3
      IF(I.GT.300)GOTO 30
      SOLD=S(I-3)
      IF(ABS(SOLD-SS).GT.EPS*(1.+ABS(SS))/2.) GOTO 10
      SUM=SUM+SS
      I=I-4
      N(L)=0
      L=L-1
   20 CONTINUE
      IF(L.EQ.1) GOTO 40
      N(L)=N(L)-1
      EPS=EPS/RED
      IF(N(L).NE.0) GOTO 10
      I=I-1
      L=L-1
      GOTO 20
   30 WRITE(6,10000)
10000 FORMAT(' GADAP:I TOO BIG')
   40 RETURN
      END
C **********************************************************************

      SUBROUTINE GADAP2(A0,B0,FL,FU,F,EPS,SUM)
C
C   PURPOSE           - INTEGRATE A FUNCTION F(X,Y) OF TWO VARIABLES
C   METHOD            - ADAPTIVE GAUSSIAN IN BOTH DIRECTIONS
C   USAGE             - CALL GADAP2(A0,B0,FL,FU,F,EPS,SUM)
C   PARAMETERS  A0    - LOWER X-LIMIT (INPUT,REAL)
C               B0    - UPPER X-LIMIT (INPUT,REAL)
C               FL    - USER SUPPLIED FUNCTION FL(X) GIVING THE LOWER
C                       Y-LIMIT FOR A GIVEN X-VALUE
C                       (INPUT,REAL FUNCTION)
C               FU    - USER SUPPLIED FUNCTION FU(X) GIVING THE UPPER
C                       Y-LIMIT FOR A GIVEN X-VALUE
C                       (INPUT,REAL FUNCTION)
C               F     - USER SUPPLIED FUNCTION F(X,Y) TO BE INTEGRATED
C                       (INPUT,REAL FUNCTION)
C               EPS   - DESIRED ACCURACY (INPUT,REAL)
C               SUM   - CALCULATED VALUE FOR THE INTEGRAL (OUTPUT,REAL)
C   PRECISION         - SINGLE
C   REQ'D PROG'S      - FL,FU,F,GADAPF
C   AUTHOR            - THOMAS JOHANSSON, LDC,1973
C
	IMPLICIT NONE
	Integer NUM,IFU,I,L,N
      COMMON/GADAP1/ NUM,IFU
	Real F,FL,FU,GADAPF,A,B,F1,F2,F3,S,A0,B0,SS,SOLD
	Real DSUM,F1F,F2F,F3F,AA,BB,RED,SUM,EPS,AY,BY,W1,U2,C,X
      EXTERNAL F,FL,FU
      DIMENSION A(300),B(300),F1(300),F2(300),F3(300),S(300),N(300)

      DSUM(F1F,F2F,F3F,AA,BB)=5./18.*(BB-AA)*(F1F+1.6*F2F+F3F)
      IF(EPS.LT.1.0E-8) EPS=1.0E-8
      RED=1.4
      L=1
      I=1
      SUM=0.
      C=SQRT(15.)/5.
      A(1)=A0
      B(1)=B0
      X=0.5*(1+C)*A0+0.5*(1-C)*B0
      AY=FL(X)
      BY=FU(X)
      F1(1)=GADAPF(X,AY,BY,F,EPS)
      X=0.5*(A0+B0)
      AY=FL(X)
      BY=FU(X)
      F2(1)=GADAPF(X,AY,BY,F,EPS)
      X=0.5*(1-C)*A0+0.5*(1+C)*B0
      AY=FL(X)
      BY=FU(X)
      F3(1)=GADAPF(X,AY,BY,F,EPS)
      IFU=3
      S(1)=  DSUM(F1(1),F2(1),F3(1),A0,B0)
   10 CONTINUE
      L=L+1
      N(L)=3
      EPS=EPS*RED
      A(I+1)=A(I)+C*(B(I)-A(I))
      B(I+1)=B(I)
      A(I+2)=A(I)+B(I)-A(I+1)
      B(I+2)=A(I+1)
      A(I+3)=A(I)
      B(I+3)=A(I+2)
      W1=A(I)+(B(I)-A(I))/5.
      U2=2.*W1-(A(I)+A(I+2))/2.
      X=A(I)+B(I)-W1
      AY=FL(X)
      BY=FU(X)
      F1(I+1)=GADAPF(X,AY,BY,F,EPS)
      F2(I+1)=F3(I)
      X=B(I)-A(I+2)+W1
      AY=FL(X)
      BY=FU(X)
      F3(I+1)=GADAPF(X,AY,BY,F,EPS)
      X=U2
      AY=FL(X)
      BY=FU(X)
      F1(I+2)=GADAPF(X,AY,BY,F,EPS)
      F2(I+2)=F2(I)
      X=B(I+2)+A(I+2)-U2
      AY=FL(X)
      BY=FU(X)
      F3(I+2)=GADAPF(X,AY,BY,F,EPS)
      X=A(I)+A(I+2)-W1
      AY=FL(X)
      BY=FU(X)
      F1(I+3)=GADAPF(X,AY,BY,F,EPS)
      F2(I+3)=F1(I)
      X=W1
      AY=FL(X)
      BY=FU(X)
      F3(I+3)=GADAPF(X,AY,BY,F,EPS)
      IFU=IFU+6
      IF(IFU.GT.5000) GOTO 40
      S(I+1)=  DSUM(F1(I+1),F2(I+1),F3(I+1),A(I+1),B(I+1))
      S(I+2)=  DSUM(F1(I+2),F2(I+2),F3(I+2),A(I+2),B(I+2))
      S(I+3)=  DSUM(F1(I+3),F2(I+3),F3(I+3),A(I+3),B(I+3))
      SS=S(I+1)+S(I+2)+S(I+3)
      I=I+3
      IF(I.GT.300)GOTO 30
      SOLD=S(I-3)
      IF(ABS(SOLD-SS).GT.EPS*(1.+ABS(SS))/2.) GOTO 10
      SUM=SUM+SS
      I=I-4
      N(L)=0
      L=L-1
   20 CONTINUE
      IF(L.EQ.1) GOTO 40
      N(L)=N(L)-1
      EPS=EPS/RED
      IF(N(L).NE.0) GOTO 10
      I=I-1
      L=L-1
      GOTO 20
   30 WRITE(6,10000)
10000 FORMAT(' GADAP:I TOO BIG')
   40 RETURN
      END

      FUNCTION GADAPF(X,A0,B0,F,EPS)
	IMPLICIT NONE
	Integer NUM,IFU,I,L,N
	Real F,A,B,F1,F2,F3,S,DSUM,F1F,F2F,F3F,AA,BB,EPS,RED
	Real SUM,C,A0,B0,X,W1,U2,SS,SOLD,GADAPF
      COMMON/GADAP1/ NUM,IFU
      EXTERNAL F
      DIMENSION A(300),B(300),F1(300),F2(300),F3(300),S(300),N(300)

      DSUM(F1F,F2F,F3F,AA,BB)=5./18.*(BB-AA)*(F1F+1.6*F2F+F3F)
      IF(EPS.LT.1.0E-8) EPS=1.0E-8
      RED=1.4
      L=1
      I=1
      SUM=0.
      C=SQRT(15.)/5.
      A(1)=A0
      B(1)=B0
      F1(1)=F(X,0.5*(1+C)*A0+0.5*(1-C)*B0)
      F2(1)=F(X,0.5*(A0+B0))
      F3(1)=F(X,0.5*(1-C)*A0+0.5*(1+C)*B0)
      IFU=3
      S(1)=  DSUM(F1(1),F2(1),F3(1),A0,B0)
   10 CONTINUE
      L=L+1
      N(L)=3
      EPS=EPS*RED
      A(I+1)=A(I)+C*(B(I)-A(I))
      B(I+1)=B(I)
      A(I+2)=A(I)+B(I)-A(I+1)
      B(I+2)=A(I+1)
      A(I+3)=A(I)
      B(I+3)=A(I+2)
      W1=A(I)+(B(I)-A(I))/5.
      U2=2.*W1-(A(I)+A(I+2))/2.
      F1(I+1)=F(X,A(I)+B(I)-W1)
      F2(I+1)=F3(I)
      F3(I+1)=F(X,B(I)-A(I+2)+W1)
      F1(I+2)=F(X,U2)
      F2(I+2)=F2(I)
      F3(I+2)=F(X,B(I+2)+A(I+2)-U2)
      F1(I+3)=F(X,A(I)+A(I+2)-W1)
      F2(I+3)=F1(I)
      F3(I+3)=F(X,W1)
      IFU=IFU+6
      IF(IFU.GT.5000) GOTO 40
      S(I+1)=  DSUM(F1(I+1),F2(I+1),F3(I+1),A(I+1),B(I+1))
      S(I+2)=  DSUM(F1(I+2),F2(I+2),F3(I+2),A(I+2),B(I+2))
      S(I+3)=  DSUM(F1(I+3),F2(I+3),F3(I+3),A(I+3),B(I+3))
      SS=S(I+1)+S(I+2)+S(I+3)
      I=I+3
      IF(I.GT.300)GOTO 30
      SOLD=S(I-3)
      IF(ABS(SOLD-SS).GT.EPS*(1.+ABS(SS))/2.) GOTO 10
      SUM=SUM+SS
      I=I-4
      N(L)=0
      L=L-1
   20 CONTINUE
      IF(L.EQ.1) GOTO 40
      N(L)=N(L)-1
      EPS=EPS/RED
      IF(N(L).NE.0) GOTO 10
      I=I-1
      L=L-1
      GOTO 20
   30 WRITE(6,10000)
10000 FORMAT(' GADAP:I TOO BIG')
   40 GADAPF=SUM
      EPS=EPS/RED
      RETURN
      END
	 
