C------------------------------------------------------------------------
      Subroutine SMtimb
C--Timelike branching of emitted gluons
      Include 'SMallx.inc'
      Double Precision Qold,ynow,SMrgen,Qnow
      Integer I,J,K
      If (Ifin.eq.0) return
      Wt=P(6,Ifin)
      J=Ifin
      Do 500 I=1,Ifin
         J=J+1
         If (J.gt.Imax) then
            Print *, ' Ran out of space on event',Jev
C        Call SMprev
            Jfin=Imax

            return
         Endif
         Qold=P(8,I)
         Told=Log(Qold/QCDLam)
         Call SMvdif(4,P(1,I-1),P(1,I),P(1,J))
c--Set mass to 0 (NB timelike masses yet to be included)
         P(5,J)=0.
         P(6,J)=1.
         P(7,J)=Float(I)
         P(8,J)=Qold
         K=J
  100    continue
         If (Told.le.Tg) then
            Jfin=J
            Told=Tg+1.E-5
         Endif
         If (tevol) then
            Call SMqtem(.true.)
         Else
            Ttem=Tg
         Endif
         If (Ttem.lt.Tgg) then
            P(7,K)=-P(7,K)
            If (K.eq.J) then
C--Finished this jet
               go to 500
            Else
c--Check next branch
               K=K+1
               Told=Log(P(8,K)/QCDLam)
               go to 100
            Endif
         Else
C--Choose large z
            ynow=Exp(Ttem*(Tg/Ttem)**SMrgen(1)-Ttem)
            znow=1.-ynow
            Qnow=znow*Qtem
            If (Qnow.lt.Qg) then
C--Outside phase space
               Told=Ttem
               go to 100
            Else
C--Store new branches
C  n.b. First branch will tend to have larger z
               J=J+1
               Call SMvsca(5,znow,P(1,K),P(1,J))
               P(6,J)=1.
               P(7,J)=Float(K)
               P(8,J)=Qnow
               J=J+1
               Call SMvsca(5,ynow,P(1,K),P(1,J))
               P(6,J)=1.
               P(7,J)=Float(K)
               P(8,J)=Qtem-Qnow
c--Check next branch
               K=K+1
               Told=Log(P(8,K)/QCDLam)
               go to 100
            Endif
         Endif
  500 continue
      Jfin=J
      End
