C
C smqtem and szvalnew for full splitting function
C copy from fullsplitt.f:     26787 Sep 21 14:43 fullsplitt.f
c
      Subroutine Szvalnew
C
C new version 9/7/2001
C
C--Chooses momentum fraction z for small-x branching
C  Cleaned-up version 24/10/91
C  All-loop has norm'n of small z part with no zmin
C  according to Kwiecinski Martin Sutton
C
C  changed hannes
C  All-loop has no non-sudakov normalisation
C  also alphas changed, now including cutoff for freezing alphas=0.6
C
C now also including non-singular terms according to Gavins proposal
C
C------------------------------------------------------------------------
      Include 'SMallx.inc'

      Common/gcom/g0,g1,gtot
      Double Precision asb,g0,g1,TQt,zmax,F,Ff,gtot,S2asb,arg
	Double Precision SMfreq,SMgsin,SMrgen
      Double Precision Fmin,Fmax
      Double Precision TQtp,Qlam0,xmin1
      Double Precision Pgtot,Pg1,Pg2
      Data Fmin,Fmax/0.0000001,0.9999999/
      Data Qlam0/0.71/
	Integer nsidx
	common /myns/nsidx
	Integer nf
      Double Precision Lambda,QQg	
	Common/hardme/Lambda,QQg,nf
	Real slo,shi,eps,g1p,g1f,g0p,g0f
	Double Precision g1_sudak,result
	Double Precision wz,Splitt,z1,Splitt0
	Double Precision gtotw,wz0,wz1
	Logical mytest
	Data mytest/.false./
	External g1p,Splitt
	External g0p,Splitt0
	
	Double Precision Qtemp,Capbp,QCDlamp
	Common/g1int/Qtemp,Capbp,QCDlamp,zmax
	Double Precision Qtem0,QQt0,xmin0,zmax0,Qg0
	Common/g0int/Qtem0,QQt0,xmin0,asb,zmax0,Qg0
	Double Precision Nonsud0,Nonsud
	External Nonsud0,Nonsud
CCCCCCCCCCCCCCCCCCCCCCCCCC
C for Sudakov (smqtem.f) B is fixed: B=0.5	
C choose BB: 0, 0.5 , 1.	
	Double Precision BB
	Common /splitting/ BB
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision BBsave
	Double Precision asbmy
	External asbmy
	
	Double Precision alp_dns,as
	Integer Ismallz
	Common /smallz/ Ismallz,alp_dns,as
	
	Double Precision D_ns,asold
	Double Precision zmin
      Double Precision Dfreq,DGAUSN
      Double Precision zero
      
      Data zero/0d0/
		
	Logical First
	Data First/.True./

c this is alphas/(2pi) ala bryan
      TQt=Log(QQt/QCDLam)
c new try with min(QQt,Qlam0)	
	Qlam0 = Qg
      TQtp=Log((dmax1(QQt,Qlam0))**2/QCDLam**2)
      asb= Capb/TQtp
c      write(6,*) ' asb ',Capb,TQtp,QQt,Qlam0,QCDLam
c      write(6,*) ' asb = ',asb

	If(First) Then
      BBsave = BB
	if(Ipgg.eq.1.or.Ipgg.eq.3) then 
	write(6,*) ' using full splitting function :',Ipgg
c	write(6,*) ' P = asb[(1-z)/z + (1-B)z(1-z)] Delta_ns +',
c     &' asb[z/(1-z) + Bz(1-z)] Delta_s'
	write(6,*) ' with B = ',BBsave
	else
	write(6,*) ' using sing part of splitting function :',Ipgg
	endif
	If(ns_sel.eq.-1) then
        write(6,*) ' Deltans is old standard one '
	elseif(ns_sel.eq.0) then
	  write(6,*) ' Deltans: as(k), sing parts, cut '
	elseif(ns_sel.eq.1) then
	  write(6,*) ' Deltans: as(k), full splitting, cut '
	elseif(ns_sel.eq.2) then
	  write(6,*) ' Deltans: as(q), sing parts, cut '
	elseif(ns_sel.eq.3) then
	  write(6,*) ' Deltans: as(q), full splitting, cut '
	endif
c      write(6,*) ' set scale to q '
c      write(6,*) ' Deltans is new one '
c      if(onel) then
c	write(6,*) ' One-Loop  '
c	else
c	write(6,*) ' Delta_ns and Pgg with alphas(q) everywhere '
c	endif
	write(6,*) ' new version: cutoff for asb = ',Qlam0
	write(6,*) ' asb =C_A/pi alpha_s ~ alpha_s '
	write(6,*) ' max asb = ',Capb/Log(Qlam0**2/QCDLam**2)
	First=.false.
	endif
CCCCCCCCCCCCCCCCCCCCCCCCCC
      BB = BBsave
c      write(6,*) ' szvalnew BB = ',BB
      Ismallz = 0
	alp_dns=1.	
	Wg=1.
	Wz=1.
	D_ns = 1.
C First get proper alphas
	asold=asbmy(QQt)
      if(Ipgg.ge.2) then
	  as= asbmy(scal*Qtem)
	else
	  as= asbmy(scal*QQt)
	endif
      alp_dns = as 	
	Qtemp=Qtem
	Qtem0=Qtem
	QQt0=QQt
	xmin0=xmin
	Capbp=Capb
	QCDlamp=QCDlam
      zmax=(1.-Qg/Qtem)
	zmax0 = zmax
	Qg0 = Qg
      g1 = .5*Capb*Log(Ttem/Tg)
	
cc	slo=0.  ! leave out
cc	shi=1.  ! leave out
cc	eps=0.0001  ! leave out
cc	call gadap(slo,shi,g1p,eps,g1f)  ! leave out
c	if(zmax.le.xmin/xg) then 
c	   write(6,*) ' zmax < xmin/xg ',zmax,xmin/xg,xmin,xg
c 	   write(6,*) ' g1 = ',g1,' g1p = ',g1f
c	endif
c	g1=g1f ! for test
      If (onel) then
         g0=0.
	   zmin = xmin/xg
	   xmin0 = zmin
         If (zmax.gt.zmin) g0=asb*log(zmax/zmin)
cc	   slo=0.  ! leave out
cc	   shi=1.  ! leave out
cc	   eps=0.0001  ! leave out
cc	   call gadap(slo,shi,g0p,eps,g0f)  ! leave out
         gtot=g0+g1
         If (SMrgen(1)*gtot.le.g1) then
            znow=1.-exp(Ttem*((Tg/Ttem)**SMrgen(2)-1.))
         Else
            Nsoft=Nsoft+1
            znow=zmin*(zmax/zmin)**SMrgen(3)
c		Ismallz = 1
         Endif
      Else
         S2asb=Sqrt(2.*asb)
         arg=S2asb*(Ttem-TQt+Log(zmax))
cc         F=SMfreq(arg)
         F=DFREQ(arg) ! changed because of numeric problems in SMFREQ
c         write(6,*) ' freq ',F,DFREQ(arg),SMfreq(arg)
c kt>qt
c         write(6,*) 'SMfreq(0) ',SMfreq(0),SMfreq(zero),dfreq(0),dfreq(zero)
         if(QQt.ge.Qtem) then
            g0 = asb/S2asb*sqrt(2.*3.1415) *F*exp(asb*(Ttem-TQt)**2)
ctestc kt>zmax*qt
         elseif(QQt.ge.zmax*Qtem) then
            g0 = asb/S2asb*sqrt(2.*3.1415)*F
         elseif(QQt.lt.zmax*Qtem) then
            Pg1=asb*sqrt(2.*3.1415)/S2asb*DFREQ(zero)
            Pg2=asb*log(zmax*Qtem/QQt)
            g0 = Pg1+Pg2
         else
            write(6,*) ' this should never happen ',QQt,Qtem,zmax
         endif
cc	   slo=0. ! leave out
cc	   shi=1. ! leave out
cc	   eps=0.0001 ! leave out
cc	   call gadap(slo,shi,g0p,eps,g0f) ! leave out
c
         if(g0.ne.g0) then
           write(6,*) 'problem in  smzvalgg', g0
         endif
         
         gtot=g0+g1
         If (SMrgen(1)*gtot.le.g1) then
            znow=1.-exp(Ttem*((Tg/Ttem)**SMrgen(2)-1.))
            if(znow.gt.zmax) write(6,*) ' 1. smzvalgg: znow>zmax ',znow,zmax
		nsidx = 0
         Else
            if(QQt.lt.zmax*Qtem) then
               If (SMrgen(4)*g0.gt.Pg1) then
                  xmin1 = QQt/Qtem
                  znow=xmin1*(zmax/xmin1)**SMrgen(5)
            if(znow.gt.zmax) write(6,*) ' 2. smzvalgg: znow>zmax ',znow,zmax
			nsidx = 3
               else
                  Nsoft=Nsoft+1
                  Ff=SMrgen(3)*DFREQ(zero)
c                  write(6,*) ' smzvalgg ',SMrgen(3),DFREQ(0),FF
                  If (Ff.lt.Fmin) then
                     znow=xmin*0.5
           if(znow.gt.zmax) write(6,*) ' 3. smzvalgg: znow>zmax ',znow,zmax
                  Elseif (Ff.gt.Fmax) then
                     znow=zmax*Fmax
           if(znow.gt.zmax) write(6,*) ' 4. smzvalgg: znow>zmax ',znow,zmax
                  Else
c                     znow=QQt/Qtem*exp(SMgsin(Ff)/S2asb)
                     znow=QQt/Qtem*exp(DGAUSN(Ff)/S2asb)
           if(znow.gt.zmax) then
           write(6,*) ' 5. smzvalgg: znow>zmax ',znow,zmax,qqt,qtem,S2asb,asb
           write(6,*) ' 5. smzvalgg: g0, g1 ',g0,g1,Ff,DGAUSN(Ff)
            
           endif
c                     write(6,*) '1st smgsin ',smgsin(Ff),DGAUSN(Ff)
                  Endif
			nsidx =2
               Endif
            else
               Nsoft=Nsoft+1
               Ff=SMrgen(3)*F
               If (Ff.lt.Fmin) then
                  znow=xmin*0.5
               Elseif (Ff.gt.Fmax) then
                  znow=zmax*Fmax
               Else
c                  znow=QQt/Qtem*exp(SMgsin(Ff)/S2asb)
                  znow=QQt/Qtem*exp(DGAUSN(Ff)/S2asb)
c                  write(6,*) '2nd smgsin ',smgsin(Ff),DGAUSN(Ff)

               Endif
		   nsidx = 1
            Endif
            if(znow.gt.zmax) then
              write(6,*) ' smzvalgg: z> zmax ',znow,' zmax ',zmax
              D_ns = 0
	  	  alp_dns = as * D_ns
              else
c Here apply the weight for the small z generation
		  Ismallz = 1
              D_ns=	Nonsud(znow)
		  alp_dns = as * D_ns
            Endif 	
         Endif
      Endif	  

	if(znow.ne.znow) then
	  write(6,*) ' problem in szvalnew g0,g1:',g0,g1
        write(6,*) ' QQt,Qtem,zmax ',QQt,Qtem,zmax
	  endif
	  

	  
c	gtot = g0f  + g1f  ! leave out  
c calculate here g1_sudakov, for proper norm	
	slo=0.
	shi=1.
	eps=0.0001
	BB=0.5
c      write(6,*) ' before gadap BB= ',BB
	call gadap(slo,shi,g1p,eps,g1f)
c	write(6,*) ' g1 = ',g1,' g1_sudakov = ',g1f
	g1_sudak=g1f
c do the z weighting	
      BB = BBsave
      z1=1.-znow            
	D_ns=	Nonsud(znow)
c	wz = as*Splitt0(znow)*D_ns + asbmy(scal*Qtem)*Splitt(z1)
c	write(6,*) ' as,1/z,1/(1-z),nonsud = ',as/asold
c     &	,splitt0(znow)*znow,Splitt(z1)*z1,D_ns/Nonsud0(znow) 
c	wz = wz/(asold/znow*Nonsud0(znow) + asbmy(scal*Qtem)/z1)
c      wg = gtot * wz /g1_sudak
c      write(6,*) ' before splitt BB= ',BB
	wz0 = as*Splitt0(znow)*D_ns/(asold/znow*Nonsud0(znow))
	wz1 = asbmy(scal*Qtem)*Splitt(z1)/(asbmy(scal*Qtem)/z1)
	gtotw = g0*wz0 + g1*wz1
      if(gtotw.le.0) then
        write(6,*) ' smzvalgg: gtotw < 0 ',gtotw,g0,wz0,g1,wz1
      endif
c	write(6,*) ' wz0 = ',wz0,' wz1 = ',wz1
c	write(6,*) ' g0 = ',g0,' g1 = ',g1
c	write(6,*) ' gtotw/gtot = ',gtotw/gtot
      wg = gtotw  /g1_sudak
      if(wg.le.0) then
        write(6,*) ' smzvalgg: wg < 0 ',gtotw,g1_sudak
       endif
c end new	
c	 write(6,*) ' wg = ',wg,' wz = ',wz
	if(wg.ge.1000000) then 
c	  write(6,*) ' wg = ',wg,' wz = ',wz
c        write(6,*) ' small z:as,asold,1/z,Splitt0(z) ',
c     &  as,asold,1/znow,Splitt0(znow)
c        write(6,*) ' large z: 1/(1-z),Splitt(1-z) ',1/z1,Splitt(z1)
c	  write(6,*) ' wtot = ',gtot,' g1_sudak ',g1_sudak
c        write(6,*) ' g1 = ',g1,' g1_sudakov = ',g1f
c        write(6,*) ' .5*Capb, Log(Ttem/Tg) ',.5*Capb,Log(Ttem/Tg)
c        write(6,*) ' .Capb, Ttem,Tg ',Capb,Ttem,Tg
c	  write(6,*) ' x,z,zmax,qqt,qtem ',xg,znow,zmax,qqt,qtem
c	  write(6,*) ' zmax,xmin,xg ',zmax,xmin,xg,xmin/xg
c	  write(6,*) ' Pgg = ',Splitt0(znow)
c	  write(6,*) ' nonsud ',Nonsud(znow),' ns_old ',Nonsud0(znow)
	endif
	if(wg.ne.wg) then
	  write(6,*) ' problem in szvalnew wg:',wg,znow
	  write(6,*) ' problem in szvalnew g0,g1:',g0,g1
        write(6,*) ' QQt,Qtem,zmax ',QQt,Qtem,zmax
	  wg=0.
	  endif
	
      End
	function asbmy(xkt)
      Include 'SMallx.inc'
      Double Precision TQtp,xkt,Qlam0
	Double Precision asbmy
	Double Precision xtest
	integer nf 
	Double Precision mass(6)
	data mass/0.,0.,0.,1.5,5.0,175./
      Integer Ialps
c      data Ialps/1/
      data Ialps/2/
      Integer nfmin,nfmax
      Double Precision ALAM2,Q2EFF,Q2THR,pi,B0,B1,alphas,algq
c      Data Qlam0/0.71/
	Qlam0 = Qg	
      TQtp=Log((dmax1(xkt,Qlam0))**2/QCDLam**2)
c new approach ala shirkov
      xtest=xkt/QCDLam
      if(xtest.lt.0.9999.or.xtest.gt.1.0001) then
c        TQtp=Log(xkt**2/QCDLam**2) + QCDLam**2/(QCDLam**2-xkt**2)
	else 
c	  TQtp = 0.5
c	  write(6,*) ' asbmy: xtest = ',xtest,xkt,QCDLam
	Endif
c old version
      asbmy = Capb/TQtp
c      write(6,*) ' old asbmy: = ',Capb/TQtp
	pi=4.*atan(1.)
      q2eff = xkt**2     
      nfmin = 3
      nfmax = 5
      nf = 4
      alam2 = qcdlam**2
c alphas from PYTHIA      
C...Evaluate first or second order alpha_strong.
  100 IF(NF.GT.MAX(2,nfmin)) THEN
        Q2THR=mass(NF)**2
        IF(Q2EFF.LT.Q2THR) THEN
          NF=NF-1
c          ALAM2=ALAM2*(Q2THR/ALAM2)**(2D0/(33D0-2D0*NF))
c          write(6,*) nf
          if(nf.eq.3) then
             ALAM2=ALAM2*(Q2THR/ALAM2)**(2./27.)
           if(Ialps.eq.2) ALAM2=ALAM2*(log(Q2THR/ALAM2))**(107./2025)
          endif
          GOTO 100
        ENDIF
      ENDIF
  110 IF(NF.LT.MIN(8,nfmax)) THEN
        Q2THR=mass(NF+1)**2
        IF(Q2EFF.GT.Q2THR) THEN
          NF=NF+1
c          ALAM2=ALAM2*(ALAM2/Q2THR)**(2D0/(33D0-2D0*NF))
          if(nf.eq.5) then 
             ALAM2=ALAM2*(ALAM2/Q2THR)**(2./23.)
             if(Ialps.eq.2) ALAM2=ALAM2*(log(Q2THR/ALAM2)**(-2.*963./13225.))
          endif
          if(nf.eq.6) then 
             ALAM2=ALAM2*(ALAM2/Q2THR)**(2./21.)
             if(Ialps.eq.2) ALAM2=ALAM2*(log(Q2THR/ALAM2)**(-2.*321./3381.)) 
          endif
          GOTO 110
        ENDIF
      ENDIF
	if(nf.gt.6.or.nf.le.0) write(6,*) nf,q2
	
      B0=(33D0-2D0*NF)/6D0
      ALGQ=LOG(MAX(1.0001D0,Q2EFF/ALAM2))
      IF(Ialps.EQ.1) THEN
        alphas=MIN(10.0,2.*pi/(B0*ALGQ))
      ELSE
        B1=(153D0-19D0*NF)/6D0
        alphas=MIN(10.0,2.*pi/(B0*ALGQ)*(1.-B1*LOG(ALGQ)/
     &  (B0**2*ALGQ)))
      ENDIF

      asbmy = alphas
c      write(6,*) ' new alphas ',alphas,qcdlam,b0,algq,q2eff
	return
	end
	
      function g1p(y)
	
	Implicit None
	Real g1p,y
	Double Precision g1t,z1,z1min,z1max
	Double Precision zmax,asb
	Double Precision Qtem,Capb,QCDlam
	Common/g1int/Qtem,Capb,QCDlam,zmax
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision splitt,asbmy
	External splitt,asbmy
c z1= 1-z	
c z1min= = Q0/q, z1max=1
       z1min=1.-zmax
	 z1max=1.
	 z1= z1min*(z1max/z1min)**y
c	 asb= 0.5*Capb/log(qtem*z1/QCDlam)
c	 asb=asbmy(qtem*z1)
       g1t = asbmy(scal*qtem*z1) *Splitt(z1)	 
	 g1t=g1t*z1*log(z1max/z1min)
	 g1p=g1t
	 return
	 end
	 
      function g0p(y)
	
	Implicit None
	Real g0p,y
	Double Precision g0t,z1,z1min,z1max,asb
	Double Precision Qtem,QQt,xmin,zmax,Qg
	Common/g0int/Qtem,QQt,xmin,asb,zmax,Qg
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision Splitt0,Nonsud,asbmy
	External Splitt0,Nonsud,asbmy
	Double Precision as
      z1min=xmin
	
ccc	z1min=dmax1(0.1,z1min)
ccc	z1min=dmin1(zmax,z1min)
	
	
	z1max=zmax
	z1= z1min*(z1max/z1min)**y
c	write(6,*) ' Splitt0 z1,xmin,asb ',z1,xmin,asb
	as=asbmy(scal*QQt)
      if(Ipgg.ge.2) then
c	write(6,*) ' asmy (q) Ipgg: ',Ipgg
	as= asbmy(scal*Qtem)
	else
c	write(6,*) ' asmy (k) Ipgg: ',Ipgg
	as=asbmy(scal*QQt)
	endif
      g0t = as *Splitt0(z1)*Nonsud(z1)	
c	write(6,*) ' splitt0 ',Ipgg,z1,Splitt0(z1),Nonsud(z1) 
	g0t=g0t*z1*log(z1max/z1min)
	g0p=g0t
	
	return
	end
	Function Splitt(z1)
	Implicit None
	Integer Ipgg,ns_sel
	Double Precision scal
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision Splitt,z1
	Double Precision BB
	Common /splitting/ BB
c      write(6,*) ' splitt BB= ',BB,Ipgg
	If(Ipgg.eq.0.or.Ipgg.eq.2) then
c first the simple 1/(1-z)=1/z1	 
c	   write(6,*) ' splitt sing. part Ipgg: ',Ipgg
	  Splitt=1./z1
	  else
c now gavins version
c 	   write(6,*) ' splitt full  Ipgg: ',Ipgg
       Splitt = ((1.-z1)/z1 +BB*(1.-z1)*z1)
c	  Splitt=1./z1
	endif
	Return
	End 
	 
	
      Function Splitt0(z)
	Implicit None
	Integer Ipgg,ns_sel
	Double Precision scal
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision Splitt0,z,z1
	Double Precision BB
	Common /splitting/ BB
	z1 = z
c first the simple 1/z	 
	If(Ipgg.eq.0.or.Ipgg.eq.2) then
c	   write(6,*) ' splitt0 sing. part Ipgg: ',Ipgg
         Splitt0=1./z1
	   else
c now gavins version
c	   write(6,*) ' splitt0 full  Ipgg: ',Ipgg
         Splitt0 = (1.-z1)/z1 + (1.-BB)*z1*(1.-z1)
	 endif
	 Return
	 End 
	 
      Function Nonsud(zz)
	Implicit None
      Logical       onel,tevol,hspot,powin,afix
      Common/SMlcom/onel,tevol,hspot,powin,afix
	
	Double Precision Nonsud,z,zz
	Double Precision Nonsud1,z1,ktqt,asb,z0,z0c,z01
	Double PRecision Nonsud2
	Double Precision BB
	Common /splitting/ BB
	Double Precision Qtem,QQt,xmin,zmax,Qg
	Common/g0int/Qtem,QQt,xmin,asb,zmax,Qg
	Double Precision Qtemp,Capbp,QCDlamp,zmax1
	Common/g1int/Qtemp,Capbp,QCDlamp,zmax1
	Double Precision Q0	
	Double Precision term1,term2,term3,term4,term5,term6,term7
	Double Precision t0,B,k,q
	Double Precision tq,tk,tc,zc,zt
	Integer ncall
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision t1,t2,t3,t4,t5,t6,t7,t8,t9,t10
	Double Precision t11,t12,t13,t14,t15,t16,t17,t18,t19
	Double Precision t20,t21,t22,t23,t24,t25,t26,t27,t28,t29
	Double Precision t30,t31,t32,t33,t34,t35,t36,t37,t38,t39
	Double Precision t40,t42,t41,t43,t45,t46,t47,t48
	Double Precision t50,t51,t52,t53,t55,t56,t58,t59
	Double Precision t62,t63,t65,t66,t68
	Double Precision t70,t71,t74,t75,t76
	Double Precision t80,t82,t85,t92,t94,t95
	Double Precision t102,t107,t108
	Double Precision a0,b0,c0,d0
	Double Precision one
	Double Precision Ei
	External Ei

c ns_sel = -1: standard non sudakov old
c ns_sel = 0: standard non sudakov with cut
c ns_sel = 1: full splitting
c ns_sel = 2: alphas(q) sing. terms
c ns_sel = 3: alphas(q) full splitting
      Integer Insq
c     Insq = 0 non-sudakov with alphasq with hannes treatment
c	Insq = 1 non-sudakov with alphasq with gavin treatment
      Data insq/0/
	data ncall/0/
	Double Precision asbmy
	External asbmy
	Logical first
	Data first/.true./
	if(first) then 
	   write(6,*) ' non-sudakov selection : ns_sel = ',ns_sel
	   write(6,*) ' Insq = ',Insq
	   first=.false.
	endif
	if(onel) then
	  Nonsud = 1.
	  else 
	
	z1=zz
	ktqt=QQt/Qtem
	if(ktqt.ge.1.) then
	  z0= 1.
	Elseif(z1.lt.ktqt.and.ktqt.le.1.) then
	  z0=ktqt
	elseif(ktqt.le.z1) then
	  z0=z1
	else
	  write(6,*) ' Nonsud : this should never happen '
	Endif
	if(z1.gt.z0) then
	   write(6,*) ' Nonsud z1,z0',z1,z0,qtem,qqt
	endif
c	  if(QQt.lt.Qtem) write(6,*) ' QQt,Qtem ',QQt,Qtem 
      k=QQt
c      k=max(QQt,Qg)
      q=Qtem
      Q0=Qg  
      Q0=0.2
c      Q0=0.5
c      Q0=0.7
c      Q0=0.9
c      Q0=1.1
c      Q0=0.71
c      Q0=0.6
cccc      Q0=0.9
      z=z1
      tk = log(k**2/QCDlamp**2)
	tq = log(q**2/QCDlamp**2)
	tc = log(Q0**2/QCDlamp**2)
	zc = Q0/q
	zt = max(z1,zc)
c	zt = z1
c now gavins version
	B=BB
	if(tk.lt.tc) then 
c	  write(6,*) ' Nonsud0: tk<tc '
	endif
	if(ns_sel.eq.-1) then
         Nonsud1 =  log(z0/z1)*log(k**2/z0/z1/q**2)
         Nonsud1 =  -asbmy(scal*k)*Nonsud1
c	   write(6,*) ' nonsudakov old : ',ns_sel
	elseif(ns_sel.eq.0) then
c	   write(6,*) ' nonsudakov old with cut : ',ns_sel
c the simple non - sudakov
	   if(tk.lt.tc) then
	     Nonsud1 = 0.
	   else
           Nonsud1 =  log(z0/zt)*log(k**2/z0/zt/q**2)
	   if(zc.gt.z1) then      
              Nonsud1 = Nonsud1+(log(zc/z1))*log(k**2/Q0**2)
	   endif
         Nonsud1 =  -asbmy(scal*k)*Nonsud1
	   endif  
c	write(6,*) z0,z1,qqt,qtem,asb
	
	elseif(ns_sel.eq.1) then
c	   write(6,*) ' nonsudakov full splitt with cut : ',ns_sel
	   if(tk.lt.tc) then
	     t0 = 0.
	   else           
c
c
c here comes the new part
           t0 = -log(k/z0/q)**2+log(k/z0/q)*z0**2+z0**2/2-
     #          B*log(k/z0/q)*z0**2-
     #          z0**2*B/2-2*z0*log(k/z0/q)-
     #          2*z0-2.D0/3.D0*z0**3*log(k/z0/q)-2.D0/9.D0*z0**3+
     #          2.D0/3.D0*B*z0**3*log(k/z0/q)+2.D0/9.D0*z0**3*B+
     #          log(k/zt/q)**2-log(k/zt/q)*zt**2-
     #          zt**2/2+B*log(k/zt/q)*zt**2+zt**2*B/2+2*zt*log(k/zt/q)+
     #          2*zt+2.D0/3.D0*zt**3*log(k/zt/q)+2.D0/9.D0*zt**3-
     #          2.D0/3.D0*B*zt**3*log(k/zt/q)-2.D0/9.D0*zt**3*B
           
            If(Insq.eq.0) then
	        if(zc.gt.z1) then      
                t1 = -log(k/zc/q)**2+log(k/zc/q)*zc**2+zc**2/2-
     #          B*log(k/zc/q)*zc**2-
     #          zc**2*B/2-2*zc*log(k/zc/q)-
     #          2*zc-2.D0/3.D0*zc**3*log(k/zc/q)-2.D0/9.D0*zc**3+
     #          2.D0/3.D0*B*zc**3*log(k/zc/q)+2.D0/9.D0*zc**3*B+
     #          log(k/z1/q)**2-log(k/z1/q)*z1**2-
     #          z1**2/2+B*log(k/z1/q)*z1**2+z1**2*B/2+2*z1*log(k/z1/q)+
     #          2*z1+2.D0/3.D0*z1**3*log(k/z1/q)+2.D0/9.D0*z1**3-
     #          2.D0/3.D0*B*z1**3*log(k/z1/q)-2.D0/9.D0*z1**3*B
                t0 = t0 + t1
	        endif
     
 	      Elseif(Insq.eq.1) then
c now gavins version ( for full splitting fct )
	          if(zc.gt.z1) then      
                   t1 = 2*log(k/q0)*log(zc)-2*log(k/q0)*zc-
     #	       2.D0/3.D0*log(k/q0)*zc**3+
     #             log(k/q0)*zc**2+2.D0/3.D0*log(k/q0)*B*zc**3-
     #             log(k/q0)*B*zc**2-2*log(k/q0)*log(z1)+
     #             2*log(k/q0)*z1+2.D0/3.D0*log(k/q0)*z1**3-
     #             log(k/q0)*z1**2-2.D0/3.D0*log(k/q0)*B*z1**3+
     #             log(k/q0)*B*z1**2
                   t0 = t0 + t1
c		     write(6,*) ' reached here ',t0,t1
	          endif
	      endif
	   endif
         Nonsud1 =  -asbmy(scal*k)*t0
ccc         Nonsud1 =  -asbmy(2.*k)*t0
c         Nonsud1 =  -asbmy(4.*k)*t0
c         write(6,*) ' nonsud ',asbmy(k),asbmy(2*k),k
	elseif(ns_sel.eq.2) then
c	zt = max(z1,zc)
c	   write(6,*) ' nonsudakov as(q)  with cut : ',ns_sel
c
c	write(6,*) ' nonsud ',asbmy(k),asbmy(2*k),k
c the simple non - sudakov

c here non sudakov with alphas(q) 
	   if(tk.lt.tc) then
	      Nonsud1 = 0.
	   else
            Nonsud1 = 0.5*log(tk/(tq+2.*log(z0)))*tq+
     &          log(tk/(tq+2*log(z0)))*log(z0)+0.5*tq+log(z0) -
     &         (0.5*log(tk/(tq+2.*log(zt)))*tq+
     &          log(tk/(tq+2*log(zt)))*log(zt)+0.5*tq+log(zt))
c            Nonsud1 = log(tk/(tq+2*log(z0)))*tq/2+
c     &	          log(tk/(tq+2*log(z0)))*log(z0)+
c     &                log(z0)-log(tk/(tq+2*log(zt)))*tq/2-
c     &                log(tk/(tq+2*log(zt)))*log(zt)-log(zt)
c            if(Nonsud1.ne.Nonsud2) write(6,*) Nonsud1,Nonsud2
            If(Insq.eq.0) then
               Nonsud1 =  Nonsud1 * Capbp 
	         if(zc.gt.z1) then      
   	            z01=zc
	            ktqt=QQt/Qtem
                  if(ktqt.ge.1.) then
	              z0c= 1.
	              z0c=z01
	            Elseif(z01.lt.ktqt.and.ktqt.le.1.) then
	              z0c=min(ktqt,z01)
	            elseif(ktqt.le.z01) then
	              z0c=z01
	            else
	              write(6,*) ' Nonsud : this should never happen '
	            Endif 
	            Nonsud1 = Nonsud1 + asbmy(q0)*
     &	       log(z0c/z1)*log(k**2/z0c/z1/q**2)
	         endif
 	      Elseif(Insq.eq.1) then
	         if(zc.gt.z1) then      
                 Nonsud1 = Nonsud1+(log(zc)-log(z1))*log(tk/tc)
	         endif
               Nonsud1 = Nonsud1 * Capbp  
	      endif
            if(Nonsud1.ne.Nonsud1) then
	        write(6,*) ' problem with new Non Sudakov '
	        write(6,*) ' z0,z1 ',z0,z1,k,q
	        write(6,*) ' log(tk/(tq+2*log(z0)))',
     #	     log(tk/(tq+2.*log(z0)))
	        write(6,*) ' log(tk/(tq+2*log(z1)))',
     #           log(tk/(tq+2.*log(z1)))
	        write(6,*) ' tq ',tq,' tk ',tk,log(z0),log(z1)
	        write(6,*) '  Non - Suadkov: ',Nonsud1
            endif
	   endif
         Nonsud1 = -Nonsud1  
	elseif(ns_sel.eq.3) then
c here non sudakov with fullspiltting and alphas(q) 
	   if(tk.lt.tc) then
	     t0 = 0.
	     Nonsud1 = 0.
	   else
           one = 1.d0
           t1 = log(tk)
           t3 = tq/2
           t4 = log(zt)
           t5 = t3+t4
           t6 = log(t5)
           t7 = zt**2
           t8 = t7*zt
           t9 = t6*t8
           t12 = t6*t7
           t14 = log(z0)
           t16 = 3./2.*tq
           t17 = exp(-t16)
           a0=-3*t4-t16
           t20 = Ei(one,a0)
           t24 = z0**2
           t25 = t24*z0
           t28 = 2*tq
           t31 = log(t28+4*t14)
	     b0=-3*t14-t16
           t36 = Ei(one,b0)
           t39 = exp(-t3)
           t40 = -t14-t3
           t41 = Ei(one,t40)
           t45 = log(-t40)
           t47 = exp(-tq)
	     c0=-2*t14-tq
           t50 = Ei(one,c0)
           t56 = t45*t25
           t58 = -z0*t1-t9/3-t6*zt-t4+t12/2+t1*t14+t14-t17*t20/3+
     #          t6*t4-t25*t1/3
     #          -tq*t31/2+t17*t36/3+t39*t41+t24*t1/2+t45*z0-t47*t50/2+
     #          zt*t1-t7*t1/2+t56/3
           t62 = log(t28+4*t4)
           t65 = t45*t24
           t70 = B*t17
           t80 = B*t47
	     d0=-2*t4-tq
           t92 = Ei(one,d0)
           t95 = Ei(one,-t5)
           t107 = -t1*t4+tq*t62/2-t65/2+t8*t1/3-t45*t14+t70*t20/3-
     #           t24*B*t1/2-
     #           t56*B/3-t12*B/2+t80*t50/2+t25*B*t1/3-t70*t36/3+t9*B/3+
     #           t47*t92/2-t39
     #           *t95+t7*B*t1/2+t65*B/2-t8*B*t1/3-t80*t92/2
           t108 = t58+t107

           t0 = t108
           Nonsud1 = -t0 * Capbp 
	     t0 = 0
           If(Insq.eq.0) then
c              Nonsud1 =  -t0 * Capbp 
	        if(zc.gt.z1) then      
   	           z01=zc
	           ktqt=QQt/Qtem
                 if(ktqt.ge.1.) then
	              z0c= 1.
	              z0c=z01
	           Elseif(z01.lt.ktqt.and.ktqt.le.1.) then
	              z0c=min(ktqt,z01)
	           elseif(ktqt.le.z01) then
	              z0c=z01
	           else
	             write(6,*) ' Nonsud : this should never happen '
	        Endif 
           
              t0 = -log(k/z0c/q)**2+log(k/z0c/q)*z0c**2+z0c**2/2-B*
     #	   log(k/z0c/q)*
     #         z0c**2-z0c**2*B/2-2*log(k/z0c/q)*z0c-2*z0c-2.D0/3.D0*
     #         z0c**3*log(k/z0c/q)
     #         -2.D0/9.D0*z0c**3+2.D0/3.D0*B*z0c**3*log(k/z0c/q)+
     #         2.D0/9.D0*z0c**3*B+log(k/z1/q)**2-log(k/z1/q)*z1**2-
     #         z1**2/2+B*log(k/z1/q)*z1**2+z1**2*B/2
     #         +2*log(k/z1/q)*z1+2*z1+2.D0/3.D0*z1**3*log(k/z1/q)+
     #         2.D0/9.D0*z1**3
     #         -2.D0/3.D0*B*z1**3*log(k/z1/q)-2.D0/9.D0*z1**3*B
              t0 = - asbmy(q0)* t0 
              if(t0.gt.0) write(6,*) 'exp(t0) > 0 ',t0
	        Nonsud1 = Nonsud1+ t0
              if(Nonsud1.gt.0) write(6,*) 'exp(Nonsud1) > 0 ',Nonsud1
		  endif
c	        Nonsud1 = Nonsud1/2
c		  write(6,*) ' here ',Nonsud1,t0,insq
 	     Elseif(Insq.eq.1) then
	        if(zc.gt.z1) then      
                 t0 = 2*log(k/q0)*log(zc)-2*log(k/q0)*zc-
     #	     2.D0/3.D0*log(k/q0)*zc**3+
     #           log(k/q0)*zc**2+2.D0/3.D0*log(k/q0)*B*zc**3-
     #           log(k/q0)*B*zc**2-2*log(k/q0)*log(z1)+
     #           2*log(k/q0)*z1+2.D0/3.D0*log(k/q0)*z1**3-
     #           log(k/q0)*z1**2-2.D0/3.D0*log(k/q0)*B*z1**3+
     #           log(k/q0)*B*z1**2
                 t0=-asbmy(scal*k)*t0
                 Nonsud1 = Nonsud1 + t0 
c		  write(6,*) ' here ',Nonsud1,t0,insq
		     
	        endif
	     Endif

           if(Nonsud1.ne.Nonsud1) then
	        write(6,*) ' problem with new Non Sudakov '
	        write(6,*) ' z0,z1 ',z0,z1,k,q
	        write(6,*) '  Non - Suadkov: ',Nonsud1,t0,t108
           endif
	   endif
	else 
	  write(6,*) '  Non - Suadkov: ',ns_sel,' not yet implemented '
        stop
      endif


      Nonsud1 = exp(Nonsud1)
     
     
	If(Nonsud1.lt.0.0.or.Nonsud1.gt.1.0001) Then
	  ncall=ncall+1
	  If(ncall.le.1000) then
	  write(6,*) ' Problem with new Non - Suadkov: ',Nonsud1,ns_sel
c	  write(6,*) ' QQt,Qtem ',QQt,Qtem
	  endif 
	  Nonsud1 = 1.
	Endif
c	Nonsud1 = 1.
      Nonsud = Nonsud1
	endif
	Return
	End 
      Function Ei(x1,x2)
	Implicit None
	Double Precision x1,x2,Dexpin,Ei
	Integer i
	External Dexpin
	if(x1.eq.1.) then
	  Ei=dexpin(x2)
	  else
	  write(6,*) ' Ei: i= ',x1,' not implemented '
	  Endif
c	  write(6,*) ' Ei = ',ei
	Return
	End 
      Function Nonsud0(z)
	Implicit None
      Logical       onel,tevol,hspot,powin,afix
      Common/SMlcom/onel,tevol,hspot,powin,afix
	Double Precision Nonsud0,z
	Double Precision Nonsud1,z1,ktqt,asb,z0
	Double Precision BB
	Common /splitting/ BB
	Double Precision Qtem,QQt,xmin,zmax,Qg
	Common/g0int/Qtem,QQt,xmin,asb,zmax,Qg
	Double Precision asbmy
	External asbmy
	if(onel) then 
	 Nonsud0 = 1.
	 else
	z1=z
	ktqt=QQt/Qtem
	if(ktqt.ge.1.) then
	  z0= 1.
	  Elseif(z1.lt.ktqt.and.ktqt.le.1.) then
	  z0=ktqt
	  elseif(ktqt.le.z1) then
	  z0=z1
	  else
	  write(6,*) ' Nonsud : this should never happen '
	  Endif
c the simple non - sudakov	 
	Nonsud1 =  -asbmy(QQt)*log(z0/z1)*log(QQt**2/z0/z1/Qtem**2)
c	write(6,*) z0,z1,qqt,qtem,asb
      Nonsud1 = exp(Nonsud1)
	If(Nonsud1.lt.0.0.or.Nonsud1.gt.1.0) Then
	write(6,*) ' Problem with old Non - Suadkov: ',Nonsud1
	Endif
c	Nonsud1 = 1.
      Nonsud0 = Nonsud1
	endif
	 Return
	 End 
	
