C
c
      Subroutine Szvalqg 
C
C new version 9/7/2001
C
C--Chooses momentum fraction z for small-x branching
C  q -> g + q: P_g = 2 Cf * 1/z
C
C------------------------------------------------------------------------
      Include 'SMallx.inc'

      Common/gcom/g0,g1,gtot
      Double Precision asb,g0,g1,TQt,zmax,F,Ff,gtot,S2asb,arg
	Double Precision SMfreq,SMgsin,SMrgen
      Double Precision Fmin,Fmax
      Double Precision TQtp,Qlam0,xmin1
      Double Precision Pgtot,Pg1,Pg2
      Data Fmin,Fmax/0.0000001,0.9999999/
      Data Qlam0/0.71/
	Integer nsidx
	common /myns/nsidx
	Integer nf
      Double Precision Lambda,QQg	
	Common/hardme/Lambda,QQg,nf
	Real slo,shi,eps,g1p,g1f,g0p,g0f
	Double Precision g1_sudak,result
	Double Precision wz,Splitt,z1,Splitt0
	Logical mytest
	Data mytest/.false./
	External g1p,Splitt
	External g0p,Splitt0
	
	Double Precision Qtemp,Capbp,QCDlamp
	Common/g1int/Qtemp,Capbp,QCDlamp,zmax
	Double Precision Qtem0,QQt0,xmin0,zmax0,Qg0
	Common/g0int/Qtem0,QQt0,xmin0,asb,zmax0,Qg0
	Double Precision Nonsud0,Nonsud
	External Nonsud0,Nonsud
CCCCCCCCCCCCCCCCCCCCCCCCCC
C for Sudakov (smqtem.f) B is fixed: B=0.5	
C choose BB: 0, 0.5 , 1.	
	Double Precision BB
	Common /splitting/ BB
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision asbmy
	External asbmy
	
	Double Precision alp_dns,as
	Integer Ismallz
	Common /smallz/ Ismallz,alp_dns,as
	
	Double Precision D_ns,asold
	Double Precision zmin
      Double Precision Dfreq
	
	Logical First
	Data First/.True./
	Double Precision Cf,Ca
	Ca = 3d0
	Cf = 4d0/3d0

c this is alphas/(2pi) ala bryan
      TQt=Log(QQt/QCDLam)
c new try with min(QQt,Qlam0)	
      TQtp=Log((dmax1(QQt,Qlam0))**2/QCDLam**2)
      asb= Capb/TQtp

	If(First) Then
	write(6,*) ' using quark splitting function :'
	write(6,*) ' new version: cutoff for asb = ',Qlam0
	write(6,*) ' asb =C_A/pi alpha_s ~ alpha_s '
	write(6,*) ' max asb = ',Capb/Log(Qlam0**2/QCDLam**2)
	First=.false.
	endif
CCCCCCCCCCCCCCCCCCCCCCCCCC
      Ismallz = 0
	alp_dns=1.	
	Wg=1.
	Wz=1.
	Qtemp=Qtem
	Qtem0=Qtem
	QQt0=QQt
	xmin0=xmin
	Capbp=Capb
	QCDlamp=QCDlam
      zmax=(1.-Qg/Qtem)
	zmax0 = zmax
	Qg0 = Qg
      g1 = .5*Capb*Log(Ttem/Tg)
	g1 = g1 * Cf/Ca
 	g1_sudak=g1  ! new
	g1=0.
	slo=0.
	shi=1.
	eps=0.0001
cccc	call gadap(slo,shi,g1p,eps,g1f)
c	write(6,*) ' g1 = ',g1,' g1p = ',g1f
      If (onel) then
         g0=0.
	   zmin = xmin/xg
c         If (zmax.gt.xmin) g0=asb*log(zmax/xmin)
         If (zmax.gt.zmin) g0=asb*log(zmax/zmin)* Cf/Ca
         gtot=g0+g1
	   slo=0.
	   shi=1.
	   eps=0.0001
cccc	   call gadap(slo,shi,g0p,eps,g0f)
c 	write(6,*) ' g0 = ',g0,' g0p = ',g0f
cccc	   g0=g0f
         
         gtot=g0+g1
         If (SMrgen(1)*gtot.le.g1) then
            znow=1.-exp(Ttem*((Tg/Ttem)**SMrgen(2)-1.))
c correct first for the 1-z part pnly	
            z1=1.-znow
cccc            wz = z1*Splitt(z1)
         Else
            Nsoft=Nsoft+1
c            znow=xmin*(zmax/xmin)**SMrgen(3)
            znow=zmin*(zmax/zmin)**SMrgen(3)
C First get proper alphas
	      asold=asbmy(QQt)
            if(Ipgg.ge.2) then
c	        write(6,*) ' asmy (q) Ipgg: ',Ipgg
	        as= asbmy(scal*Qtem)
	      else
c	        write(6,*) ' asmy (k) Ipgg: ',Ipgg
	        as=asbmy(scal*QQt)
	      endif
		Ismallz = 1
            D_ns=	1.
c Here apply the weight for the small z generation		
cccc		wz = as/asold * Splitt0(znow) * znow 
		alp_dns = as 	
         Endif
      Else
         S2asb=Sqrt(2.*asb)
         arg=S2asb*(Ttem-TQt+Log(zmax))
         F=dfreq(arg)
c here is the new code
check without norm to integral over non-sudakov
c kt>qt
c         write(6,*) 'dfreq(0) ',dfreq(0)
         if(QQt.ge.Qtem) then
            g0 = asb/S2asb*sqrt(2.*3.1415) *F*exp(asb*(Ttem-TQt)**2)
		g0 = g0 * Cf/Ca
c kt>zmax*qt
         elseif(QQt.ge.zmax*Qtem) then
            g0 = asb/S2asb*sqrt(2.*3.1415)*F
		g0 = g0 * Cf/Ca
         elseif(QQt.lt.zmax*Qtem) then
            Pg1=asb*sqrt(2.*3.1415)/S2asb*dfreq(0)* Cf/Ca
            Pg2=asb*log(zmax*Qtem/QQt)* Cf/Ca
            g0 = Pg1+Pg2
         else
            write(6,*) ' this should never happen ',QQt,Qtem,zmax
         endif
	   slo=0.
	   shi=1.
	   eps=0.0001
cccc	   call gadap(slo,shi,g0p,eps,g0f)
c 	write(6,*) ' g0 = ',g0,' g0p = ',g0f
cccc	   g0=g0f
c
         
         gtot=g0+g1
         If (SMrgen(1)*gtot.le.g1) then
            znow=1.-exp(Ttem*((Tg/Ttem)**SMrgen(2)-1.))
		nsidx = 0
c correct first for the 1-z part pnly	
            z1=1.-znow
cccc            wz = z1*Splitt(z1)
c	      write(6,*) ' large z ',wz,znow
         Else

            if(QQt.lt.zmax*Qtem) then
               If (SMrgen(4)*g0.gt.Pg1) then
                  xmin1 = QQt/Qtem
                  znow=xmin1*(zmax/xmin1)**SMrgen(5)
			nsidx = 3
               else
                  Nsoft=Nsoft+1
                  Ff=SMrgen(3)*dfreq(0)
                  If (Ff.lt.Fmin) then
                     znow=xmin*0.5
                  Elseif (Ff.gt.Fmax) then
                     znow=zmax*Fmax
                  Else
                     znow=QQt/Qtem*exp(SMgsin(Ff)/S2asb)
                  Endif
			nsidx =2
               Endif
            else
               Nsoft=Nsoft+1
               Ff=SMrgen(3)*F
               If (Ff.lt.Fmin) then
                  znow=xmin*0.5
               Elseif (Ff.gt.Fmax) then
                  znow=zmax*Fmax
               Else
                  znow=QQt/Qtem*exp(SMgsin(Ff)/S2asb)
               Endif
		   nsidx = 1
            Endif
            if(znow.gt.zmax) write(6,*) ' z> zmax ',znow,' zmax ',zmax
c Here apply the weight for the small z generation
C First get proper alphas
	      asold=asbmy(QQt)
            if(Ipgg.ge.2) then
c	        write(6,*) ' asmy (q) Ipgg: ',Ipgg
	        as= asbmy(scal*Qtem)
	      else
c	        write(6,*) ' asmy (k) Ipgg: ',Ipgg
	        as=asbmy(scal*QQt)
	      endif
		Ismallz = 1
            D_ns=	Nonsud(znow)
cccc		wz = as/asold * Splitt0(znow) * znow * D_ns/Nonsud0(znow)
		alp_dns = as * D_ns	
         Endif
      Endif	  

	if(znow.ne.znow) then
	  write(6,*) ' problem in szvalqg g0,g1:',g0,g1
        write(6,*) ' QQt,Qtem,zmax ',QQt,Qtem,zmax
	  endif
	  
	  
cccc	gtot = g0f  + g1f 
c calculate here g1_sudakov, for proper norm	
	slo=0.
	shi=1.
	eps=0.0001
	BB=0.5
cccc	call gadap(slo,shi,g1p,eps,g1f)
c	write(6,*) ' g1 = ',g1,' g1_sudakov = ',g1f
cccc	g1_sudak=g1f
      wg=gtot/g1_sudak
c end new	
	if(wg.ge.1000) then 
	  write(6,*) ' wg = ',wg,' wz = ',wz
	  write(6,*) ' x,z,qqt,qtem ',xg,znow,qqt,qtem
cccc	  write(6,*) ' Pgg = ',Splitt0(znow)
	  write(6,*) ' nonsud ',Nonsud(znow),' ns_old ',Nonsud0(znow)
	endif
	wg = wg*wz  
	if(wg.ne.wg) then
	  write(6,*) ' problem in szvalqg wg:',wg,znow
	  write(6,*) ' problem in szvalqg g0,g1:',g0,g1
        write(6,*) ' QQt,Qtem,zmax ',QQt,Qtem,zmax
	  wg=0.
	  endif
	
      End
	
