
      Subroutine glugrid(iflag)
c obtain the unitegrated gluon density as a function of xg,kt**2
c in a grid

C--Event analysis
      Include 'SMallx.inc'
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP
      Double Precision PHEP,VHEP,EVWGT
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     + JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C---Event weight
C   N.B. weights must be renormalized to momentum sum
      COMMON/HEPWGT/EVWGT
	Double Precision BB
	Common /splitting/ BB
	Integer Ipgg,ns_sel
	Double Precision scal
	common/Pggsel/Ipgg,ns_sel,scal
      Double Precision tmax,p_max
      Common/mygrid/tmax,p_max
      Integer nobran,ikincut
      common/myvar/nobran,ikincut
	Double Precision Qbarmy,Qbar_min,Qbar_max
      Common/mglubran/Qbarmy,Qbar_min,Qbar_max
      Integer neve
	common/myevt/neve
      Double Precision sum
	Integer nloop
	common/myloop/nloop
	Double precision wt0
	common/myweight/wt0
c my variables
      Double Precision wt0my
      Double Precision xp2,xkt2,x_g,wtxg
c      common/cwnco1/xp2,xkt2,x_g,wtxg

      Integer Nbx,Nbk,Nbp
      Parameter (Nbx=50)
c      Parameter (Nbk=42)
      Parameter (Nbk=50)
c      Parameter (Nbk=1)
c      Parameter (Nbp=20)
      Parameter (Nbp=50)
      Double Precision X1(0:Nbx+1),X2(0:Nbk+1),X3(0:Nbp+1)
      Double Precision X1M(0:Nbx),X2M(0:Nbk),X3M(0:Nbp)
      Double Precision x1b(0:Nbx),x2b(0:Nbk),x3b(0:Nbp)
      Double Precision xgx(2,0:Nbx,0:Nbk,0:Nbp)
	Double Precision xgx_f(2,0:Nbx,0:Nbk,0:Nbp)
      Double Precision xm11(0:Nbx),xm21(0:Nbk),xm31(0:Nbp)
      Double Precision xm12(0:Nbx),xm22(0:Nbk),xm32(0:Nbp)
      Double Precision xm1(0:Nbx),xm2(0:Nbk),xm3(0:Nbp)

	Double Precision x3norm(2,0:Nbp)
      Double Precision Val1,Val2,Val3
      Integer I,J,K,Iflag,Irr,Err
      Integer ix1,ix2,ix3
      Integer nval2,ncall,Nrejx1,Nrejx2
      Double Precision x1minL,x1maxL,x1dif,x2dif,x3dif
      Double Precision x2minL,x2maxL,q2min,q2max,p3max,p3min
      Double Precision Xgnorm,Xgn,xgmy,wtmy
c limits
      Double Precision x1min,x1max,x2min,x2max,x3min,x3max
      Double Precision x1dm,x2dm,x3dm
	Double Precision x3lmin,x3lmax,x3ldif
	Double Precision Qgmin,Xin
      CHARACTER   FILNAME*132
      Common/gludatf/filname
      Character*5 xxxx
      Integer Kid
      Common /SMbran1/Kid(0:1000)
	Integer ki
	Integer nold
	Double Precision kt2
      LOGICAL ex
	data nold/1/
      Data xxxx/'gluon'/
	data ncall/0/
	Integer iprint
	Data iprint/0/

c      write(6,*) ' glugrid ',iflag
	
      If(iflag.eq.1) Then
	   do ki=1,2
	   do k=0,nbp
	   x3norm(ki,k) = 0.
	   enddo
	   enddo

c initilaze grid
cThis is the new stuff
c xg
c         x1min=0.00001
	   x1min = xmin
cccc         x1min=0.000001 ! new (not really needed for TEVATRON)
         x1max=xmax

         x1minL=log(x1min)
         x1maxL=log(x1max)
         x1dif=(x1maxL-x1minL)/Real(Nbx)
         Do I=0,Nbx+1
            x1(I) = x1minL + x1dif*Real(I)
         Enddo
	   Do I=0,Nbx
            x1m(I) = (x1(i) + x1(i+1))/2.
            x1b(i) = x1(i+1) - x1(i)
c		write(6,*) ' log(x) bins ',i,x1b(i)
         Enddo
c parameters for glugrid:

         q2min = 0.001 ! new
c	   q2max = 300.
         q2max = qmax**2/4.

	   x2minL=log(q2min)
	   x2maxL=log(q2max)
	   x2dif=(x2maxL-x2minL)/real(nbk)
         Do I=0,Nbk+1
            x2(I) = x2minL + x2dif*Real(I)
	   Enddo

	   Do I=0,Nbk
            x2m(I) = (x2(i) + x2(i+1))/2.
            x2b(i) = x2(i+1) - x2(i)
c		write(6,*) ' log(kt2) bins ',i,x2m(i),exp(x2m(i))
         Enddo
c p_max

         Qgmin = max(Qg,QCDlam)
         p3min=Qgmin
cc         p3min=Qs
	   p3max=Qmax
c	   p3max=40. !test
	   x3lmin=log(p3min)
	   x3lmax=log(p3max)
c	   write(6,*) ' p3min,p3max ',p3min,p3max,x3lmin,x3lmax
	   x3ldif = (x3lmax-x3lmin)/Real(Nbp)	
         Do I=0,Nbp+1
            x3(I) = x3lmin + x3ldif*Real(I)
         Enddo
	   Do I=0,Nbp
	      x3m(i) = (x3(i) + x3(i+1))/2.
		x3b(i) = x3(i+1) - x3(i)
c		write(6,*) ' log(p) bins ',i,x3b(i),x3m(i)
         Enddo
	
         Qbar_min=x3(0)
	   Qbar_max=x3(Nbp)

c zero xg
         Do ki=1,2
         Do I=0,Nbx
            Do J=0,Nbk
               Do K=0,Nbp
                  xgx(ki,I,J,K)=0.
                  xgx_f(ki,I,J,K)=0.
               Enddo
            Enddo
         Enddo
         Enddo
         Xgnorm = 0.
         Xgn = 0.
      Elseif(iflag.eq.2) Then

c fill in values
	   if(nloop.ne.nold) Then
	    nold=nloop

	    endif
         xgmy = xg
         wtmy = wt
c         write(6,*) ' glugrid ',xg,Wt,Wini,Excode
         Val1 = log(xgmy)
	
         kt2=P(1,Ifin)**2+P(2,Ifin)**2
         Val2 = log(kt2)
         x_g=xgmy
         wtxg=wtmy*xgmy
c new test
         xp2 = p_max	
	
c	   write(6,*) 'glugrid: xg,kt2,p_max,x0,wt',xgmy,kt2,p_max,x0,wtmy
	
	   if(sqrt(kt2).ge.xp2.and.onel) then
c	     write(6,*) ' glugrid kt > qmax ',sqrt(kt2),xp2
	     endif
c end new	
c         Val3 = xp2
         Val3 = log(xp2)
         If(Val3.lt.x3(0)) Then
            write(6,*) ' val3 = ',val3,' too low: x3(0) = ',x3(0),p_max
            Val3 = x3(0)
         elseif(val3.gt.x3(Nbp+1)) Then
cc            write(6,*) ' val3 = ',val3,' too high: x3(Nbp) = ',x3(Nbp)
cc            Val3 = x3(Nbp+1)
               return
         endif
         ix3=-1
   40    ix3 = ix3 + 1
         if(ix3.gt.Nbp) then
            write(6,*) ' ix3 outside grid ',ix3,Nbp
         else
            if(val3.gt.x3(ix3+1)) goto 40
         Endif

	   ki=1
         
c use ki=2 for the nobran probability
         if(wt0.gt.0) then
            wt0my = wt0
            else
            wt0my=1.
            endif
	   x3norm(ki,ix3) = x3norm(ki,ix3) + x0*wt0my  ! 22
	   x3norm(2,ix3) = x3norm(2,ix3) + x0*wt0my  ! 22
	   Xin = Xin + x0
	   if (Excode.ne.0) then
c            write(6,*) ' glugrid return: Excode = ',Excode 
            return
         endif
         If (Wini.eq.0.0) then
            write(6,*) ' glugrid return: Wini = 0 ',Wini
           return
         endif
c	   x3norm(ix3) = x3norm(ix3) + x0  ! 21
	   
	   
         If(Val1.lt.x1(0)) Then
            write(6,*) ' val1 = ',val1,' too low: x1(0) = ',x1(0)
            Nrejx1 = Nrejx1 + 1
            Val1 = x1(0)
            return
         elseif(val1.gt.x1(Nbx+1)) Then
            write(6,*) ' val1 = ',val1,' too high: x1(Nbx) = ',x1(Nbx+1)
            Val1 = x1(Nbx+1)
		return
         endif
 	   
         ix1=-1
   20    ix1 = ix1 + 1
         if(ix1.gt.Nbx) then
            write(6,*) ' ix1 outside grid ',ix1,Nbx
         else
            if(val1.gt.x1(ix1+1)) goto 20
         Endif
         If(Val2.lt.x2(0)) Then
c            write(6,*) ' val2 = ',val2,' too low: x2(0) = ',x2(0)
            Val2 = x2(0)
		return
         elseif(val2.gt.x2(Nbk+1)) Then
            nval2 = nval2 + 1
            if(nval2.lt.10) then
c               write(6,*) ' val2 = ',val2,' too high: x2(Nbk) = ',
c     +         x2(Nbk+1)
            endif
            Val2 = x2(Nbk+1)
		Nrejx2 = Nrejx2 + 1
            return
         endif
         ix2=-1
   30    ix2 = ix2 + 1
         if(ix2.gt.Nbk) then
            write(6,*) ' ix2 outside grid ',ix2,Nbk
         else
            if(val2.gt.x2(ix2+1)) goto 30
         Endif


         if(Ifin.eq.0) xgx(2,ix1,ix2,ix3)= xgx(2,ix1,ix2,ix3) + wtmy 
	   xgx(ki,ix1,ix2,ix3)= xgx(ki,ix1,ix2,ix3) + wtmy
         xm11(ix1)=xm11(ix1)+val1
         xm21(ix2)=xm21(ix2)+val2
         xm31(ix3)=xm31(ix3)+val3
         xm12(ix1)=xm12(ix1)+1
         xm22(ix2)=xm22(ix2)+1
         xm32(ix3)=xm32(ix3)+1
         Xgn = Xgn + wtmy*xgmy

	   ncall = ncall + 1
      Elseif(iflag.eq.3) Then

c xgx defined here is actually g(x)
c corresponds: d g(x)/dlnx = x dg(x)/dx
         if(iprint.eq.1) then
         write(6,*) Xgn,x1dif,Xgnorm,x1maxL,x1minL,Nbx
         write(6,*) 'ncall=',ncall
	   write(6,*) ' rej x1 cut ',Nrejx1,' rej x2 cut ',Nrejx2
	   write(6,*)  ' xgn/ncall =',xgn/real(ncall)
	   write(6,*) ' glugrid: X3norm = ',(X3norm(1,i),i=0,Nbp)
	   endif
         do i=0,Nbx
            if(xm12(i).ge.10) then 
              xm1(i)=xm11(i)/xm12(i)
            else
              xm1(i) = x1m(i)
            endif
         end do
         Do j=0,Nbk
            if(xm22(j).ge.10) then 
            xm2(j)=xm21(j)/xm22(j)
            else
            xm2(j) = x2m(j)
            endif
         end do
         Do k=0,Nbp
            if(xm32(k).ge.10) then 
            xm3(k)=xm31(k)/xm32(k)
            else
            xm3(k) = x3m(k)
            endif
         end do

         Do ki = 1,2
         Do I = 0,Nbx
c       write(6,*) ' entries I ',i,xgx(i,0,0),' b-width ',log10(x1b(i)),
c     +    log10(x1m(i))
            Do J = 0,Nbk
               sum = 0
               Do K = 0, Nbp
c this is the new thing
		     Xgnorm = Xnor/max(x3norm(ki,k),1.) ! for gluon/glubran

                 xgx_f(ki,I,J,K) = xgx(ki,I,J,K)/x2b(j)/x1b(i)*Xgnorm
               Enddo
            Enddo
c       write(6,*) ' norm  I ',i,xgx_f(i,0,0),xgx(i,0,0)
         Enddo
         Enddo
c print out table
c         write(6,*) ' *********************************************** '
c         write(6,*) ' ******        xA(x,kt**2,p)              ****** '
c         write(6,*) ' *********************************************** '
c         write(6,*) '|   ln(xg)  |  ln(k_t^2)  |   ln(p)  |   xA     |'
c         write(6,*) ' *********************************************** '
c         write(30,*) ' Qg0 = ',Qg,' ikincut= ',ikincut
c         write(30,*) ' ln(xg),  ln(k_t^2), ln(p),  xgx'
         do ki=1,2
c         inquire(FILE='glu.dat',EXIST=ex)
         if(ki.eq.1) then
         inquire(FILE=filname,EXIST=ex)
         write(6,*) ' glugrid: filename ',filname,ex
	   else
	     filname='nobran-'//filname
	   endif
         if(ex) then
c            open(30,FILE='glu.dat', FORM='formatted',STATUS=
            open(30,FILE=filname, FORM='formatted',STATUS=
     +      'old',IOSTAT=IRR,ERR=50 )
            else
c            open(30,FILE='glu.dat', FORM='formatted',STATUS=
            open(30,FILE=filname, FORM='formatted',STATUS=
     +      'new',IOSTAT=IRR,ERR=50 )
	   Endif
	   write(30,10000) Qg,ikincut
10000    format(' Qg0 = ',f12.8,' ikincut= ',I6)
         write(30,10001) Ipgg,ns_sel
10001    format(' Ipgg = ',I4,' ns_sel = ',I4)
         write(30,10003) QCDlam
10003    format(' QCDlam = ',f12.8)
         write(30,10100)
10100    format(' ln(xg),  ln(k_t^2), ln(p),  xgx')
         do i=0,Nbx
            do j=0,Nbk
               do k=0,Nbp
                  if(xgx_f(ki,i,j,k).gt.0.0) then
c                  write(6,100) x1m(i),x2m(j),x3m(k),xgx_f(I,J,K)
                  endif
               enddo
            enddo
         enddo
c write output to file

         do j=0,Nbk
            do i=0,Nbx
               do k=0,Nbp

                  write(30,*) x1m(i),x2m(j),x3m(k),xgx_f(ki,I,J,K)

               enddo
            enddo
         enddo
         close(30)
         enddo
         If(iprint.eq.1) then
            write(6,*) nbx,nbk,nbp
            write(6,*) ' glugrid: after before close '
	   endif
      Endif
      Return
   50 write(6,*) ' error opening file'
      Return
  100     format(' |',E12.4,' | ',F8.5,' | ',F8.5,' | ',F8.5,' |')
      End
