C----------------------------------------------------------------------
      Subroutine SMinfn
C--Choose starting conditions for branching

      Include 'SMallx.inc'
      Integer Kid
      Common /SMbran1/Kid(0:1000)

      Logical pdflib,quark,gluon,photon,kernel
      Common /SMbran2/pdflib,quark,gluon,photon,kernel
	Double Precision Xnorm
      common/smnorm/ Xnorm

      Double Precision SMrgen,SMrgau,u,yinf,frat,Qinf,Qsup
      Double Precision Rdq

	Double Precision Scale,test,xgmax,xnormn

      Double Precision  XX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20),QQ2,PP2
      Integer Ip2
      CHARACTER*20 PARM(20)
	
	Real slo,shi,xint,eps
	Integer i
	
	Double Precision xtmin,xtmax,dx,xt
	Integer nstep
	Integer nx
	Double Precision dlxmin,dlxmax,deltax,xmi,xma,sum
	Logical first,first1
	Data first/.true./,first1/.true./
	External xint

      Double Precision qgmin,qgmax,xmymin,WQG2,Wx0,xi,kt2i,ti,Qx2
      Double Precision xpq(-6:6),qg2max
      Double Precision kt,phi_k
	
	Double precision alphas,sigm0,lam,x01,r02,xgx0
	Integer nobran,ikincut
      common/myvar/nobran,ikincut
	Double precision wt0
	common/myweight/wt0
      Double Precision sigm, xmean
	
	logical saturation
c	data saturation/.true./
	data saturation/.false./
	
      
      Jev=Jev+1

101   continue
      if(nobran.eq.2) then
         qgmin = 0.000001d0
         qgmax = Sbig
         Qx2 = QGMIN*((QGMAX/QGMIN)**SMrgen(1))
         WQG2 = Qx2*LOG(QGMAX/QGMIN)
c     write(6,*) qx2,sbig
         xmymin=max(1e-7,xmin)

         x0 = xmymin*(xmax/xmymin)**SMrgen(2)
         Wx0 = x0*log(xmax/xmymin)
c--choose starting Qt
         PHI_K = 2*3.1415*Smrgen(3)
         P(1,0)= sqrt(qx2)*cos(phi_k)
         P(2,0)= sqrt(qx2)*sin(phi_k)
        Wt=1.
	  if(first) then
	     write(6,*) ' sminfn: nobran selected ',nobran
	     first=.false.
	  endif
      else

c--choose starting Qt
123     Continue
c        P(1,0)= SMrgau(1,0.0d0,Qx)
c        P(2,0)= SMrgau(2,0.0d0,Qx)
        sigm = Qx
        xmean = 0.0
        P(1,0)= SMrgau(1,xmean,sigm)
        P(2,0)= SMrgau(2,xmean,sigm)
        Wt=1.
        if(saturation) then
         qgmin = 0.000001d0
         qgmin = 0.00010001d0
         qgmax = Sbig
         qgmax = 100.
         Qx2 = QGMIN*((QGMAX/QGMIN)**SMrgen(1))
         WQG2 = Qx2*LOG(QGMAX/QGMIN)
c--choose starting Qt
         PHI_K = 2*3.1415*Smrgen(3)
         P(1,0)= sqrt(qx2)*cos(phi_k)
         P(2,0)= sqrt(qx2)*sin(phi_k)
        endif
	  Scale=P(1,0)**2+P(2,0)**2
	  If(pdflib.or.saturation) then
  	     pow0 = 0
	  endif
c	  write(6,*) quark,gluon,photon
c--choose initial x
c--power input
   10   continue
        if(kernel) then
	     if(first) then
	       write(6,*) ' sminfn: evolve only kernel '
	       first=.false.
           Endif
	     If(gluon.or.photon) then
	       Kid(0) = 21
	     else
	       Kid(0) = 1
	     Endif
           x0=0.99
           xg=x0
           xgbar=-(P(1,0)**2+P(2,0)**2+p2(5)**2*x0*(2.-x0))
     +        /(Sbig*(1.-x0))
	     xgbar =0
           P(3,0)=x0*p2(3)+xgbar*p1(3)
           P(4,0)=x0*p2(4)+xgbar*p1(4)
           Call SMumas(P(1,0))
c--proton spectator
           Call SMvdif(4,p2,P(1,0),pspec)
ctest............	
	     yphton = 1
	     yphbar = 0.
	     Wini = 1.
cend.......... test.........	
	
           q1(3)=yphton*p1(3)+yphbar*p2(3)
           q1(4)=yphton*p1(4)+yphbar*p2(4)
c--electron spectator
           Call SMvdif(4,p1,q1,espec)
c      Wt=1.
           q1(5)=-Qval
           P(6,0)=Wt
           P(7,0)=0.
           P(8,0)=0.
           Goto 334
        endif 
        If(pow0.ne.0.) then
           x0=xmin*(1.-xmp0*SMrgen(2))**q0
        Else
           x0=xmin**SMrgen(3)
        Endif
	  if(first) then
	     write(6,*) ' sminfn:  pdflib ',pdflib
	     write(6,*) ' sminfn: gluon,quark,photon ',gluon,quark,photon
	     write(6,*) ' sminfn: nobran ',nobran
	     write(6,*) ' sminfn: sat ',saturation
	     first=.false.
	  endif
c 	write(6,*) gluon,quark,photon
	  If(pdflib) then
           write(6,*) ' pdflib version is not implemented '
           write(6,*) ' Contact author '
           write(6,*) ' Program STOP '
           STOP
	  else
           if(saturation) then

	       if(first) then
	         write(6,*) ' sminfn: saturation selected ',saturation
	         first=.false.
	       endif
             SIGM0 = 29.12*2.568
	       LAM = 0.277
             X01 = 0.41/10000.
             ALPHAS = 0.2
             R02 = (X0/X01)**LAM
             glu = 3.*SIGM0*R02*SCALE*EXP(-R02*SCALE)
             xgx0 = glu/4./9.8696/ALPHAS
	       xgmax=12.
	       xgmax=1500.
             test = xgx0*WQG2/xgmax
             Wt0 = xgx0*WQG2
             Wt = Wt0
	       If (test.gt.1)then
                write(6,*) ' fatal in saturation: xgx0 > xgmax :',
     &         xgx0*WQG2,xgmax
             endif
	     else
	       If ((1.-x0)**pow1.lt.SMrgen(4)) go to 10
	     endif
	  endif
	  If(gluon.or.photon) then
	    Kid(0) = 21
	  else
	    Kid(0) = 1
	  Endif
	Endif  
c--compute xgbar
      xg=x0
      xgbar=-(P(1,0)**2+P(2,0)**2+p2(5)**2*x0*(2.-x0))
     +        /(Sbig*(1.-x0))
      if(nobran.eq.2) then
	xgbar =-Qx2/(1.d0-xg)/Sbig
	endif
      if(saturation) then
	   xgbar =0
      endif
      P(3,0)=x0*p2(3)+xgbar*p1(3)
      P(4,0)=x0*p2(4)+xgbar*p1(4)
      Call SMumas(P(1,0))


c--proton spectator
      Call SMvdif(4,p2,P(1,0),pspec)
c--choose y
      yinf=xymin/x0
      If (yinf.lt.ymin) yinf=ymin
      If (yinf.le.ymax) then
         frat=Log(ymax/yinf)
         yphton=yinf*Exp(frat*SMrgen(1))
         Wini=frat
      Else
         yphton=ymax
         Wini=0.0
      Endif
c--choose Sqrt(Q**2)
      Qinf=yphton*me/Sqrt(1.-yphton)
      If (Qinf.lt.Qmin) Qinf=Qmin
      Qsup=Sqrt(yphton*Sbig)
      If (Qsup.gt.Qmax) Qsup=Qmax
      If (Qinf.le.Qsup) then
         frat=Log(Qsup/Qinf)
         Qval=Qinf*Exp(frat*SMrgen(3))
         Wini=Wini*frat*(1.+(1.-yphton)**2)
      Else
         Qval=Qsup
         Wini=0.0
      Endif
      Call SMrazm(Qval*Sqrt(1.-yphton),q1(1),q1(2))
      yphbar=-Qval**2/Sbig
	
      q1(3)=yphton*p1(3)+yphbar*p2(3)
      q1(4)=yphton*p1(4)+yphbar*p2(4)
c--electron spectator
      Call SMvdif(4,p1,q1,espec)
      If(nobran.eq.2) then
c get weight from ccfm-data file
c set x0 = 1,Xnor =1 to get proper normalisation
	   x0 = 1.
	   Xnor = 1.
         Wini = Wini*Wqg2*Wx0
         qg2max = Sbig*yphton - Qval- 4.D0*qmas**2
	   if(qx2.gt.qg2max) Wini = 0.
      endif
c      Wt=1.
      q1(5)=-Qval
      P(6,0)=Wt
      P(7,0)=0.
      P(8,0)=0.
c choose mass and flavor for  Ichg=4
c treat charm massless
334   if(Ichg.eq.4) then
         Rdq=10.*SMrgen(1)
         Idq=4
         If (Rdq.lt.6.) Idq=3
         if(Rdq.lt.5) Idq=2
         if(Rdq.lt.1) Idq=1
         If(Idq.eq.4) Then
c            Qmas=0.25
         else
c            Qmas=0.25
         Endif
c     write(6,*) ' Qmas ',Qmas,Idq
      QQt = -9999.
      endif
      End

