C------------------------------------------------------------------------
      Subroutine SMprev
C--Prints event
      Include 'SMallx.inc'
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP
      Double Precision PHEP,VHEP,EVWGT
      PARAMETER (NMXHEP=4000)
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     + JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
C---Event weight
C   N.B. weights must be renormalized to momentum sum
      COMMON/HEPWGT/EVWGT
      Double Precision QQ,Wold,Wnew,Ql,Pold,z
      Integer I,J,Ipar,Jpar
      QQ=0.
c      write(6,*) IFIN,P(6,IFIN)
c      pause
      Print 1,Jev,Js,P(6,Ifin)
    1 Format(//9X,'Event:',I7,'   Seed: ',I12//
     +9X,'Branching record: Weight =',1PE13.4//
     +3X,'I   K         E         Qt       Ql        z      Wt')
      Wold=P(6,0)
      Do 10 I=0,Jfin
         QQt=Sqrt(P(1,I)**2+P(2,I)**2)
         Ipar=Ifix(Real(Abs(P(7,I)))+0.5)
         If (Ipar.eq.0) then
            Ipar=Max(I-1,0)
         Else
            Jpar=Ifix(Real(Abs(P(7,Ipar)))+0.5)
            If (Jpar.eq.0) Ipar=Ipar-1
         Endif
         Pold=P(3,Ipar)+P(4,Ipar)
         If (Pold.eq.0.) then
            z=0.
         Else
            z=(P(3,I)+P(4,I))/Pold
         Endif
         If (Wold.eq.0.) then
            Wnew=0.
         Else
            If (P(7,I).eq.0.) then
               Wnew=P(6,I)/Wold
            Else
               Wnew=1.
            Endif
         Endif
         Wold=P(6,I)
         Print 5,I,P(7,I),P(4,I),QQt,P(3,I),z,Wnew
    5 Format(I4,F5.0,1PE12.4,0P4F9.4)
   10 Continue
      If (EVWGT.le.0.) then
         Print 20, EVWGT
   20   FORMAT(/9X,'No HEPEVT record: EVWGT  =',1PE13.4)
      Else
         Print 30, EVWGT
   30   FORMAT(/9X,'HEPEVT record:    EVWGT  =',1PE13.4//
     +  '  IHEP IDPDG IST MO1 MO2 DA1 DA2   ',
     +  ' P-X     P-Y      P-Z    ENERGY    MASS')
         Do 40 I=1,NHEP
            Print 50, I,IDHEP(I),ISTHEP(I),JMOHEP(1,I),JMOHEP(2,I),
     +      JDAHEP(1,I),JDAHEP(2,I),(PHEP(J,I),J=1,5)
   40    Continue
      Endif
   50 FORMAT(I5,1X,I6,5I4,2F8.2,2F9.2,F8.2)
      End
